/////////////////////////////////////////////////////////////////////////////
// Name:        BackUp_Diff.cpp
/////////////////////////////////////////////////////////////////////////////

#define wxUSE_STREAMS 1

// For compilers that support precompilation, includes "wx/wx.h".
////#include "wx/wxprec.h"

//#ifdef __BORLANDC__
//    #pragma hdrstop
//#endif

//#ifndef WX_PRECOMP
    #include <wx/wx.h>
    #include <wx/log.h>
//#endif

/////#include "wx/colordlg.h>
/////#include "wx/numdlg.h>

//#include  <time.h>
//#include  <wx/gdicmn.h>
//#include  <wx/icon.h>
//#include  <wx/image.h>
/////#include  <wx/imaglist.h>
////#include  <wx/treectrl.h>
//#include  <wx/math.h>
//#include  <wx/dirdlg.h>
//#include  <wx/filedlg.h>
//#include  <wx/dir.h>
#include  <wx/filename.h>
#include  <wx/display.h>
//#include  <wx/txtstrm.h>
//#include  <wx/wfstream.h>
//#include  <wx/textfile.h>
//#include  <wx/debug.h>
//#include  <wx/stattext.h>
//#include  <wx/event.h>
////#include  <wx/tokenzr.h>

#ifdef __WIN32__
    // this is not supported by native control
    #define NO_VARIABLE_HEIGHT
#endif

#include "TopFrame.h"
#include "BackUp_Diff.h"
//#include "MyDirTraverser.h"
//#include "MyThread.h"
/////#include "Path_String_Ctl.h"

//#include "icon1.xpm"
//#include "icon2.xpm"
//#include "icon3.xpm"
//#include "icon4.xpm"
//#include "icon5.xpm"
#include "RArrow.xpm"
//#include "Backup_Diff.xpm"

#ifndef __WXMSW__
#endif

typedef  char INT_8 ;

extern int
StrToken_Breaker
( 
    const wxString & str, 
    const wxChar     delims[], 
    int      max_Tokens,
    wxString token_L[],
    INT_8    tkTyp_L[] = 0
) ;

extern int Subtract_String
            ( 
                const wxString & text_in, 
                wxChar  subt_Symb,
                const wxString & pattern,
                int       max_tokns,
                wxString tokns_L[],         //output
                int     * cnt_Parsed        //output
            );

//followin two globals are defined in MyCommon_WIn.cpp
//{
//time_t    g_FileTime_DeadBand = 2 ; //[sec] file modification-time comparison backlash
//bool      g_isCASE_SENSITIVE_FileName = false ;
//}

wxBitmap  g_Bmp_CopyDirection( RArrow_xpm ) ;
wxColour  g_Color_RootPath_BG( 255, 255, 0 ) ;

wxString  g_Dir_ExeMyself ;

wxChar    g_Setting_File_Type[] = wxT("bkdf") ;

int       menu_ID_Selct_Recent_Setting  ;
int       menu_ID_Selct_Recent_Set_File ;
int       menu_ID_Sort_Prior ;

const wxEventType  TopFRAME::EVTYP_MyThread = wxNewEventType() ;

extern wxChar   g_Recently_Used_Setting_List[] ;
extern wxChar   RC_TipStr_MenuBtn[] ;

//*****************************************************************************

IMPLEMENT_APP(MyApp)

//*****************************************************************************
//
//*****************************************************************************

bool MyApp::OnInit()
{
    extern wxChar   RC_MainWin_Title[] ;

    short   sort_Priority_Lst[ 10 ] ; //<out>
    int     nDisplay ;
    wxRect  rectDisp ;
    short   ret ;

    wxFileName fn( argv[0] ) ;
    g_Dir_ExeMyself = fn.GetPath( wxPATH_GET_VOLUME | wxPATH_GET_SEPARATOR ) ;

    // Create the main frame window
    TopFRAME *frame = new TopFRAME( RC_MainWin_Title );

    frame->Read_Setting_Data( sort_Priority_Lst );

    frame->Build_GDI() ;

        //*for Debug*/frame->m_textCtrl->AppendText( wxString::Format( wxT("argc=%d, argv[1] =[%s]"), argc, argv[1] ) );

    frame->m_DTreeCtrl->m_SortPrior_Tbl.Set_Priority( sort_Priority_Lst ) ;
    // Show the frame

    if( argc > 1 )
        frame->Read_SettingFile( wxString( argv[1] ) ) ;

    rectDisp = ::wxGetClientDisplayRect() ;
    nDisplay = wxDisplay::GetCount() ;
                wxLogDebug( wxT("Display_count= %d, rectDisp=(%d(%d),%d(%d),%d,%d)\n"), nDisplay, rectDisp.x, frame->m_X_Pos, rectDisp.y, frame->m_Y_Pos, rectDisp.width, rectDisp.height ) ;

    if( nDisplay < 2 )
    {
        if( frame->m_X_Pos >= rectDisp.width )
            frame->m_X_Pos = wxDefaultPosition.x ;
        if( frame->m_Y_Pos >= rectDisp.height )
            frame->m_Y_Pos = wxDefaultPosition.y ;
    }

    frame->SetSize( frame->m_X_Pos, frame->m_Y_Pos, frame->m_Width, frame->m_Height );

    frame->Resize();

    if( frame->m_Opt_Auto_Backup )
    {
        frame->Iconize( true ) ;
        ret = frame->Do_Backup() ; 

        if( ret == 0 )
            return true;
    }

    frame->Show(true);
    SetTopWindow( frame );

    wxCommandEvent event( wxEVT_COMMAND_MENU_SELECTED, menu_ID_Startup );
    ::wxPostEvent( frame, event );

    frame->KickOff_Diff_Check() ;//if possible, diff_check thread invoked
 
    return true;
}

