#include "wx/wxprec.h"
#include "wx/wxchar.h"
#include "wx/datetime.h"
#include "wx/string.h"
#include "wx/log.h"
#include "wx/filename.h"
#include "wx/file.h"
#include "wx/longlong.h"
#include "wx/defs.h"
#include "sys/types.h"
#include "sys/stat.h"
#include  <sys/utime.h>
#include "MyThread.h"
//#include "DualTreeBase.h"

extern  wxString g_Dir_ExeMyself ;

bool    g_isCASE_SENSITIVE_FileName = false ;//windows ̏ꍇAfile name  
                                                           //case-sensitive łȂƂ
time_t  g_FileTime_DeadBand = 2 ; //[sec] file modification-time comparison backlash

wxChar  g_Recently_Used_Setting_List[] = wxT("\\Application Data\\ToohuuDoo\\Bkdf_Setting_File.Lst") ;

//*****************************************************************************
//
//*****************************************************************************
wxString 
Get_HelpExec_Command()
{
//    wxString cmd = wxString(wxT("Start /B \"")) + g_Dir_ExeMyself + wxT("doc.htm\"") ;
    wxString cmd = wxString( wxT("cmd /C \"") ) + g_Dir_ExeMyself + wxT("doc.htm\"") ;
//    wxString cmd = wxString( wxT("\"") ) + g_Dir_ExeMyself + wxT("doc.htm\"") ;
                ::wxLogDebug( wxT("Get_HelpExec_Command() cmd=[%s]"), cmd ) ;
    return( cmd ) ;
}

//*****************************************************************************
// sgp
//*****************************************************************************

typedef struct 
{
    wxDateTime  m_Date ;
} wxStatData ;

//*****************************************************************************
// sgp
//*****************************************************************************

int 
wxStat( const wxString & path, wxStatData * /*buffer*/ )
{
    struct _stat buff ;

    int ret = _wstat( path.wchar_str(), & buff );

 //   buffer.dateTime

    return( ret );
}

//*****************************************************************************
// ̊֐́Awindows ł ʖ
//*****************************************************************************
int
Folder_Set_Times
( 
    const wxString & fullPath, 
    const wxDateTime & dtAccess, 
    const wxDateTime & dtMod 
)
{
    return( 0 ) ;
    int  ret ;
    _utimbuf utm;
    utm.actime  = dtAccess.GetTicks() ;
    utm.modtime = dtMod.GetTicks() ;

    ret = _wutime( fullPath.wchar_str(), &utm ) ;
            ::wxLogDebug( wxT("Folder_Set_Times() : ret =%d, dir =<%s>"), ret, fullPath.c_str() );
    if( ret )
    {         
        return( 0 );
    }

    return( 1 ) ;
}

//*****************************************************************************
//  00 ; Modification-time, size  
//  11 : destination Â
//  10 ; source Â
//  01 : Modification-time w̕(sec_Dead_Band)œAsize 
//  02 : Modification-time Asize قȂ
// 100 : source       File ݂Ȃ
// 101 : destination  File ݂Ȃ
//  -1 : source  File̎Asize ȂA
//  -2 : destination  File̎Asize ȂA
//*****************************************************************************

int
File_Compare_TStamp
(
    const wxString & path_Src,   //source-file fullpath 
    const wxString & path_Dst,   //destination-file fullpath
    time_t           sec_Dead_Band  //dead_band for modification-time comparing
                                    //   >= 0: [second]
)
{
    int     result ;
    time_t  band  ;
//    wxDateTime  time_Src, time_Dst ;
//    wxULongLong size_Src, size_Dst ;
    wxStructStat fbuf_S, fbuf_D;

//    wxFileName wFN_Src( path_Src );
//    wxFileName wFN_Dst( path_Dst );

    if( wxStat( path_Src, &fbuf_S) != 0 )  goto  Exit_M1 ;
    if( wxStat( path_Dst, &fbuf_D) != 0 )  goto  Exit_M2 ;
   
    band = sec_Dead_Band ; //v̗]T
    if( fbuf_S.st_size != fbuf_D.st_size ) 
    {       //size ́A̗]T݂Ȃ
        band = 0 ;
    }

    if( fbuf_S.st_mtime > fbuf_D.st_mtime + band )   goto  Exit_11 ;
    if( fbuf_S.st_mtime < fbuf_D.st_mtime - band )   goto  Exit_10 ;
    if( fbuf_S.st_size != fbuf_D.st_size )           goto  Exit_02 ;

    result = 0 ;
    if( fbuf_S.st_mtime != fbuf_D.st_mtime )
        result = 0x01 ;

 EXIT :
        //::wxLogDebug( wxT("Compare_FIle_TStamp(%ld) [%s]: tick=(%ld, %ld) -->%d"),
        //                sec_Dead_Band, path_Src, fbuf_S.st_mtime, fbuf_D.st_mtime, result );
    return( result );

 Exit_02 : result = 02 ; goto EXIT ;
 Exit_10 : result = 10 ; goto EXIT ;
 Exit_11 : result = 11 ; goto EXIT ;
 Exit_M2 : result = -2 ; goto EXIT ;
 Exit_M1 : result = -1 ; goto EXIT ;
}

//*****************************************************************************
//  ::wxCopyFile() source Qlɂ
//*****************************************************************************

int
Backup_THREAD::Copy_Fle
( 
    const wxString & fullPath_Src, 
    const wxString & fullPath_Dst 
)
{
    int   ret, reslt ;
    bool  bRet ;
    size_t nRead ;
    wxStructStat fbuf;
    wxDateTime  dtAccess, dtMod, dtCre ;
    wxTempFile tmpFile;
    wxFile dstFil, srcFil ;

    wxFileName  fn_Src( fullPath_Src ) ;
    wxFileName  fn_Dst( fullPath_Dst ) ;
            ::wxLogDebug( wxT("Backup_THREAD::Copy_Fle()  <%s>-->(%s>"), fullPath_Src, fullPath_Dst );

    if( wxStat( fullPath_Src, &fbuf) != 0 )  goto  ERR_Stat ;
        
    bRet = srcFil.Open( fullPath_Src ) ;

    if ( ! bRet )                           goto  ERR_Open ;
    // get permissions of file1

///    bRet = dstFil.Create( fullPath_Dst, true, fbuf.st_mode & 0777 ) ;
///    if( ! bRet )      goto  ERR_Create ;
    bRet = tmpFile.Open( fullPath_Dst ) ;
    if( ! bRet )                            goto  ERR_Create ;

    for( ;; )
    {
        if( m_GoOn_Flag == 0 )              goto QUITTED ;

        nRead = srcFil.Read( m_IO_Buff, m_MaxSiz_IO_Buff );
        if( nRead <= 0 )  break ;

        ret = tmpFile.Write( m_IO_Buff, nRead );
    }

    reslt = 0 ;

    tmpFile.Commit() ;
    srcFil.Close() ;

    fn_Src.GetTimes( & dtAccess, & dtMod, & dtCre ) ;
    fn_Dst.SetTimes( & dtAccess, & dtMod, & dtCre ) ;
            ::wxLogDebug( wxT("    path=<%s> sec=%d"), fullPath_Dst, dtMod.GetSecond() );
 EXIT :
             ::wxLogDebug( wxT("Copy_File()  end. -->%d"), reslt );

    return( reslt ) ;

 ERR_Stat :

    reslt = -3 ;
    goto  EXIT ;

 ERR_Open :

    reslt = -1 ;
    goto  EXIT ;

 ERR_Create :

    reslt = -2 ;
    srcFil.Close() ;

    goto  EXIT ;

 QUITTED :
        // the file probably doesn't exist or we haven't the rights to read
        // from it anyhow
//        wxLogSysError(_("Impossible to get permissions for file '%s'"),
//                      file1.c_str());
    reslt = 2 ;

    srcFil.Close() ;

    goto  EXIT ;
}

#if 0  //090708-Copy_Fle
//*****************************************************************************
//  ::wxCopyFile() source Qlɂ
//*****************************************************************************

int
Backup_THREAD::Copy_Fle
( 
    const wxString & fullPath_Src, 
    const wxString & fullPath_Dst 
)
{
    int   ret, reslt ;
    bool  bRet ;
    size_t nRead ;
    wxStructStat fbuf;
    wxDateTime  dtAccess, dtMod, dtCre ;

    wxFileName  fn_Src( fullPath_Src ) ;
    wxFileName  fn_Dst( fullPath_Dst ) ;

    if( wxStat( fullPath_Src, &fbuf) != 0 )
    {
        return( -3 ) ;
    }

    wxFile srcFil( fullPath_Src ) ;
    wxFile dstFil ;

    if ( ! srcFil.IsOpened() )  goto  ERR_Open ;
    // get permissions of file1

    bRet = dstFil.Create( fullPath_Dst, true, fbuf.st_mode & 0777 ) ;
    if( ! bRet )      goto  ERR_Create ;

    for( ;; )
    {
        if( m_GoOn_Flag == 0 )  goto QUITTED ;

        nRead = srcFil.Read( m_IO_Buff, m_MaxSiz_IO_Buff );
        if( nRead <= 0 )  break ;

        ret = dstFil.Write( m_IO_Buff, nRead );
    }

    reslt = 0 ;

 EXIT_100 :

    srcFil.Close() ;
    dstFil.Close() ;

    fn_Src.GetTimes( & dtAccess, & dtMod, & dtCre ) ;
    fn_Dst.SetTimes( & dtAccess, & dtMod, & dtCre ) ;
            ::wxLogDebug( wxT("path=<%s> sec=%d"), fullPath_Dst, dtMod.GetSecond() );
 EXIT :
 
    return( reslt ) ;

 ERR_Open :

    reslt = -1 ;
    goto  EXIT ;

 ERR_Create :

    reslt = -2 ;
    goto  EXIT ;

 QUITTED :
        // the file probably doesn't exist or we haven't the rights to read
        // from it anyhow
//        wxLogSysError(_("Impossible to get permissions for file '%s'"),
//                      file1.c_str());
    reslt = 2 ;
    goto  EXIT_100 ;
}
#endif  //090708-Copy_Fle
