#include  <stdlib.h>
#include  "wx/wx.h"
#include  "wx/dir.h"
#include  "wx/filename.h"
#include  "wx/file.h"
#include  "wx/filefn.h"
#include  "MyThread.h"
#include  "TopFrame.h"

const int    MyThread_BASE::T_LoadTree = 1 ;
const int    MyThread_BASE::T_DiffChek = 2 ;
const int    MyThread_BASE::T_Backup   = 3 ;
const int    MyThread_BASE::T_Delete   = 4 ;

//===============================================================================
//
//===============================================================================

MyThreadEVENT::MyThreadEVENT( int id ) 
   : wxCommandEvent( TopFRAME::EVTYP_MyThread, id )
{
}

//===============================================================================
//
//===============================================================================
//virtual
wxEvent * 
MyThreadEVENT::Clone(void) const 
{ 
    return new MyThreadEVENT( * this ); 
}

//##############################################################################

extern
int  Copy_Children_in_DTree
        ( 
            const DualTreeCtl_NODE * pNod_Root,
            const wxString & srcFoldr_Path,   //source  Folder path
            const wxString & dstFoldr_Path    //destination  Folder path. (݂͑邱)
                                      //  Apath ̍Ō '/' 鎖
        ) ;

//===============================================================================
//
//===============================================================================

MyThread_BASE::MyThread_BASE
( 
    int   type,
    const TopFRAME * frame
)   : Proc_SPACE( frame, 0 )
{
    m_Type = type ;
///    m_Cursor_Old = frame->GetCursor() ;//constructor Őݒ肵Ă͂Ȃ
///    Create() ;    
}

//===============================================================================
//
//===============================================================================

LoadTree_THREAD::LoadTree_THREAD
(
    const TopFRAME * frame,
    DualTreeCtl_NODE * pNod_Root,
    int   which
)       : MyThread_BASE( MyThread_BASE::T_LoadTree, frame )
{
    m_pNod_Root = pNod_Root ;
    m_Which = which ;

    m_Path_Str_Org = frame->m_DTreeCtrl->m_pRoot_Node->m_Name_L[ which ] ;
    frame->m_DTreeCtrl->m_pRoot_Node->m_DrawInf_Cursor.m_pItemBase = 0 ;//maybe no need
    frame->m_DTreeCtrl->m_Cnt_Item_DrawInf = 0 ;//maybe no need
}

//===============================================================================
//
//===============================================================================
//virtual
wxThread::ExitCode 
LoadTree_THREAD::Entry()
{
    int  ret, other_Stat ;
//    long lRet ;

    ret = Load_Children( m_pNod_Root );

    other_Stat = m_pNod_Root->m_Is_Valid_L[ 1 - m_Which ] ;

            ::wxLogDebug( wxT("LoadTree_THREAD::Entry() which= %d, ret =%d, stat=%d"),
                                                             m_Which, ret, other_Stat ); 
    MyThreadEVENT event( thread_Evt_LoadTree_Finished );

    event.m_Path_Str_Org = m_Path_Str_Org ;
    event.m_Which = m_Which ;

    event.SetInt( ret ) ;

    ::wxPostEvent( m_Frame, event );

    return( NULL );
}

