/////////////////////////////////////////////////////////////////////////////
// Name:        
// Purpose:     
// Author:      
// Modified by:
// Created:     
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

#define USE_GENERIC_TREECTRL 0

#if USE_GENERIC_TREECTRL
#include "wx/generic/treectlg.h"
#ifndef wxTreeCtrl
#define wxTreeCtrl wxGenericTreeCtrl
#define sm_classwxTreeCtrl sm_classwxGenericTreeCtrl
#endif
#endif
#include <wx/checkbox.h>
//#include <wx/tglbtn.h>
#include <wx/cursor.h>
#include <wx/bitmap.h>
#include <wx/bmpbuttn.h>
#include <wx/textctrl.h>
#include <wx/splitter.h>
#include <wx/frame.h>
///#include <wx/app.h>

#include "DualTreeBase.h"
#include "DualTree_Ctl.h"
#include "Path_String_ctl.h"
#include "File_Info_Ctl.h"

class MyThread_BASE ;
class MyThreadEVENT ;

#define m_Src_RootPath_Ctl (m_Path_Ctl[ 0 ])
#define m_Dst_RootPath_Ctl (m_Path_Ctl[ 1 ])
#define m_SrcFileInfo      (m_FileInfo_Ctl[ 0 ])
#define m_DstFileInfo      (m_FileInfo_Ctl[ 1 ])

//#############################################################################
//
//#############################################################################

class SettDATA
{
  public :
    wxString  m_Src_FileName  ;
    wxString  m_Dst_FileName  ;
    short     m_Opt_Auto_Diff_Chk  ; //==0 --> diff_check option invalid
                                     //> 0 --> diff_Check ON
                                     //< 0 --> diff_Check OFF            
    short     m_Opt_Auto_Backup ;    //> 0 --> Auto Backup

  public :

    void  Init() { m_Opt_Auto_Diff_Chk = 0 ; m_Opt_Auto_Backup = 0 ; };
};

//#############################################################################
// Define a new frame type    TopFRAME
//#############################################################################

// Define a new frame type
class TopFRAME: public wxFrame
{
  public :

////    static const wxEventType  EVTYP_Show_About ;
    static const wxEventType  EVTYP_MyThread ;

//    wxPanel      * m_SplitWin;

    Path_String_CTL   * m_Path_Ctl[ 2 ] ;
    wxBitmapButton    * m_ArrowBtn ;
    wxCheckBox        * m_DiffChkBtn ;
    wxSplitterWindow  * m_SplitWin ;
    File_Info_CTL     * m_FileInfo_Ctl[2] ;

    DualTree_CTL * m_DTreeCtrl ;
    wxTextCtrl   * m_textCtrl ;

    wxStaticText * m_MenuTip_Ctl ;//"Menu" tip str window 

    wxFont         m_Font_Deflt ;//default font 
  //-------
    wxString  m_Setting_FileName ;//݂̐ݒt@C̖O

  //------- metric data
    int       m_X_Pos,  m_Y_Pos; 
    int       m_Width,  m_Height ;//window-size
    int       m_Y_Splitter_Sash  ;//

  //-------
    int       m_Cnt_Recent_Settings   ;//ŋߎgpݒdata̐
    SettDATA  m_Recent_Settings_L[6]  ;//ŋߎgpݒdata

  //-------
    int       m_Cnt_Recent_Setting_Files   ;//ŋߎgpݒt@C̐
    wxString  m_Recent_Setting_Files_L[4]  ;//ŋߎgpݒt@C fullpath name

    //Head View spacer
    //
    int       m_X_RootPath_Ctl    ;//root-path \cntrl ̂wW. Œl
    int       m_H_RootPath_Ctl    ;//root-path \cntrl ̍  . Œl
    wxRect    m_Rect_Root_Backup_Ind ;//backup-indicator rectangle for root-source . Œl

    //
    wxRect    m_Rect_HdView_Spcer ;//
    int       m_X0_LMDown_Spcer   ;//LMOUSE-DOWN mouse wWLp
                                     // m_Rect_HdView_Spcer.x ɑ΂鑊΍W
                                     //     < 0  Ɩ
///    size_t       m_MaxSiz_IO_Buff ;//file copy p buffer-size
///    wxChar     * m_IO_Buff ;  //file copy p buffer

  //---------------------
  //thread queue :  thread  ɂ 1삵Ȃ

    short     m_Cnt_Thread_Pend  ;//(N҂ + ) thread̐
    short     m_Idx_Thread_Work  ;// thread index : 
                                     //   < 0 ȂA
    MyThread_BASE * m_Thread_L[ 5 ] ;//(N҂ + ) thread queue

  //---------------------

    short     m_Opt_Auto_Backup ;
                       
///    short        m_Diff_Check_Ind ;
///    wxCursor     m_Cursor_Old ;

  public:
    // ctor and dtor
    TopFRAME( const wxString& title );

    virtual ~TopFRAME();

///    wxMenuBar * Create_Menues() ;

    short Max_Thread_Queue() const ;
    int   Append_Thread_Queue( MyThread_BASE * pThread ) ;
    int   Check_Thread_Queue( const MyThreadEVENT * pEvt ) ;

    int   Build_GDI();

    int   Read_SettingFile( const wxString & setting_FileName ) ;
    int   Save_SettingFile( const wxString & setting_FileName ) ;

    int   Read_Setting_Data( short sort_Priority_Lst[] ) ;
    int   Save_Setting_Data() ;
    int   Add_Recently_Used_Setting_List( wxString & setting_File ) ;
    bool  Enable_Operations( bool flag ) ;

    int   Max_Recent_Settings() const ;
    int   Max_Recent_Setting_Files() const ;

    void  Select_RootFolder_OneSide( int which ) ;
    int   Open_RootFolder_OneSide( const wxString & fullPath_Root, 
                                                        int which );
    int   Open_RootFolder_OneSide_Th( const wxString & fullPath_Root, 
                                                          int which );//thread version

//    int   Copy_Children_in_DTree( const DualTreeCtl_NODE * pMother, 
//                                  const wxString & srcFoldr_Path,   //source  Folder path
//                                  const wxString & dstFoldr_Path    //destination  Folder path. (݂͑邱)
//                                 );
//    int   Copy_Children_OnFolder( const wxString & srcFoldr_Path,  //source  Folder path
//                                  const wxString & dstFoldr_Path   //destination  Folder path
//                                 );
    int   copy_Fle( const wxString & srcFullPath, 
                    const wxString & dstFullPath 
                  ) ;
    void  Show_FileCopy_Log( const wxString & src_Path, 
                             const wxString & dst_Path ) ;
    void  Show_MakeDir_Log( const wxString & path ) ;

    int   KickOff_Diff_Check();
    int   Quit_Diff_Check();
    int   Quit_Thread( int type = 0 )  const ;

    int   Is_Doing_Backup() const ;

    int   Do_Backup() ;
    int   Delete_Selected_Destines( int flag_Delete[] ) ;

    int   Show_Startup() ;

    bool  Should_Diff_Check() ;

    void  LogPut_Msg( const wxString & msg ) const ;
    void  LogPut_Format( const wxChar form[], ... ) const ;

  private:

  //Event handler

    void  OnPaint( wxPaintEvent & event );

    void  OnShow_Menu( wxCommandEvent & event ) ;
    void  OnSize( wxSizeEvent& event );
    void  OnMouseMotion( wxMouseEvent & event );
    void  OnLMouseDown( wxMouseEvent & event );
    void  OnLDoubleClick( wxMouseEvent& event );
    void  OnLMouseUp( wxMouseEvent & event );
    void  OnMouseLeave( wxMouseEvent& event );
    void  OnShow_FileInfo( wxCommandEvent & event );
    void  OnEvent_Thread( wxCommandEvent & event ) ;
    void  OnGet_RootPath( wxCommandEvent & event ) ;
    void  OnToggle_Diff_Chk( wxCommandEvent & event ) ;

  public :

    void  OnDestroy( wxWindowDestroyEvent & pEvt );

  private:

//    void  OnShow_About( wxCommandEvent & event );

  // menu callbacks

    void  OnQuit(wxCommandEvent& event);
    void  OnAbout(wxCommandEvent& event);
    void  OnHowToUse(wxCommandEvent& event);

    void  OnStartup(wxCommandEvent& event);
    void  OnDo_Backup(wxCommandEvent& event);
    void  OnQuit_Thread(wxCommandEvent& event);
    void  OnSelect_RootDir_S(wxCommandEvent& event);
    void  OnSelect_RootDir_D(wxCommandEvent& event);
    void  OnReLoad_Tree(wxCommandEvent& event);
    void  OnReset_Tree(wxCommandEvent& event);
//    void  OnRead_Recent_Set_Files(wxCommandEvent& event);
    void  OnRead_Setting(wxCommandEvent& event);
    void  OnSave_Setting(wxCommandEvent& event);
    void  OnShow_BackupOnly(wxCommandEvent& event);
    void  OnShow_DestOnly_File(wxCommandEvent& event);
    void  OnChange_Sort_Order(wxCommandEvent& event);
    void  OnChange_Sort_Priority(wxCommandEvent& event);
    void  OnBackUp_Chk_NodeAll(wxCommandEvent& event);
    void  OnBackUp_UnChk_NodeAll(wxCommandEvent& event);
    void  OnBackUp_Check_All(wxCommandEvent& event);
    void  OnBackUp_UnCheck_All(wxCommandEvent& event);
    void  OnDel_Sel_Desti(wxCommandEvent& event);

    void  OnLogger(wxCommandEvent& event);
    void  OnLogger_Copy(wxCommandEvent& event);
    void  OnLogger_Record(wxCommandEvent& event);
    void  OnSelct_Settings(wxCommandEvent& event);
    void  OnSelct_SettingFile(wxCommandEvent& event);
    void  OnDo_Check_Diffs(wxCommandEvent& event);
    void  OnEdit_Copy(wxCommandEvent& event);
    void  OnEdit_SelAll(wxCommandEvent& event);
    void  OnEdit_Erase(wxCommandEvent& event);
    void  OnSet_Preference(wxCommandEvent& event);

    //=======================

    void  OnIdle(wxIdleEvent& event);

  public :

    int   Resize();

  private:

    int   Resize_HeadView() ;

    void  CreateTreeWithDefStyle();
    void  CreateTree(long style);

    void  DoSetBold(bool bold = true);

    DECLARE_EVENT_TABLE()
};

enum CTRL_ID
{
    ctrl_ID_DiffChk = 2,
    ctrl_ID_Arrow,
    ctrl_ID_Set_Root_S,
    ctrl_ID_Set_Root_D,
    ctrl_ID_About
};

// menu and control ids
enum menu_id
{
    menu_ID_Quit  = wxID_EXIT,
    menu_ID_About = wxID_ABOUT,
    menu_ID_HowToUse = wxID_HIGHEST,
    menu_ID_Startup,
    menu_ID_Read_Setting,
    menu_ID_Save_Setting,
    menu_ID_Select_RootDir_S,
    menu_ID_Select_RootDir_D,
    menu_ID_ReLoad_Tree,
    menu_ID_Reset_Tree,
    menu_ID_Do_Backup,
    menu_ID_Quit_Thread,
    menu_ID_Show_BackupOnly,
    menu_ID_Show_DestOnly_File,
    menu_ID_Logger,
    menu_ID_Logger_Copy,
    menu_ID_Logger_Record,
    menu_ID_Check_Uncheck,
    menu_ID_BackUp_Check_All,
    menu_ID_BackUp_UnCheck_All,
    menu_ID_Change_Sort_Order,
    menu_ID_Do_Check_Diffs,
    menu_ID_Edit,
    menu_ID_Edit_Copy,
    menu_ID_Edit_SelAll,
    menu_ID_Edit_Erase,
    menu_ID_Del_Sel_Desti,
    menu_ID_Set_Preference,
    the_Last_menu_ID
    // Sort Priority list
    // recently used setting list
};

extern  int    menu_ID_Selct_Recent_Setting ;
extern  int    menu_ID_Selct_Recent_Set_File ;
extern  int    menu_ID_Sort_Prior ;
