
// For compilers that support precompilation, includes "wx/wx.h".
//#include "wx/wxprec.h"

//#ifdef __BORLANDC__
//    #pragma hdrstop
//#endif

//#ifndef WX_PRECOMP
    #include <wx/wx.h>
    #include <wx/log.h>
//#endif

///#include "wx/colordlg.h>
///#include "wx/numdlg.h>

#include  <time.h>
#include  <wx/gdicmn.h>
#include  <wx/icon.h>
#include  <wx/image.h>
///#include  <wx/imaglist.h>
//#include  <wx/treectrl.h>
#include  <wx/math.h>
#include  <wx/dirdlg.h>
#include  <wx/filedlg.h>
#include  <wx/dir.h>
#include  <wx/filename.h>
#include  <wx/txtstrm.h>
#include  <wx/wfstream.h>
#include  <wx/textfile.h>
#include  <wx/debug.h>
#include  <wx/stattext.h>
#include  <wx/event.h>
#include  <wx/strconv.h>
//#include  <wx/tokenzr.h>

#ifdef __WIN32__
    // this is not supported by native control
    #define NO_VARIABLE_HEIGHT
#endif

#include "TopFRAME.h"
#include "MyDirTraverser.h"
#include "MyThread.h"
//#include "Backup_Diff.xpm"

#ifndef __WXMSW__
#endif

typedef  char INT_8 ;

extern int
StrToken_Breaker
( 
    const wxString & str, 
    const wxChar     delims[], 
    int      max_Tokens,
    wxString token_L[],
    INT_8    tkTyp_L[] = 0
) ;

extern int 
Subtract_String
( 
    const wxString & text_in, 
    wxChar           subt_Symb,
    const wxString & pattern,
    int              max_tokns,
    wxString         tokns_L[],    //output
    int            * cnt_Parsed    //output
) ;

static int
Interpret_SettingData      //defined in this file
(
    const wxString & inText,
    SettDATA         * setData   //<out>
) ;

//extern wxChar    RC_TipStr_MenuBtn[] ;
extern wxChar    g_Recently_Used_Setting_List[] ;
//extern wxBitmap  g_Bmp_CopyDirection ;
//extern wxColour  g_Color_RootPath_BG ;

//extern wxChar   g_Recently_Used_Setting_List[] ;
//extern wxChar    RC_TipStr_MenuBtn[] ;
//extern wxBitmap  g_Bmp_CopyDirection ;
//extern wxColour  g_Color_RootPath_BG ;

extern int  Cnt_Ptr_Array( const void ** ptrArry ) ;

//*****************************************************************************
//  C:\Documents and Settings\tanaka\Application Data\ToohuuDoo\Bkdf_Setting_File.Lst
//   Read 
//*****************************************************************************

int
TopFRAME::Read_Setting_Data
( 
    short sort_Priority_Lst[] //<out>
)
{
    extern  wxChar * RCL_Sort_Name[] ;

     //wxT("Recently_Used_Setting_List") );
    static int * parm[] = { & m_X_Pos, & m_Y_Pos, & m_Width, & m_Height, & m_Y_Splitter_Sash };
    short cnt, cnt_Prir ;
    int   ret, nTkns, i, x ;
    short is_Settings ;
    long  xl  ;
    wxString   text, sub_Str[2], tokn[6] ;
    char  flg_Arry[20] ;
///    wxFileName  folder_Appli( wxTheApp->argv[0] ) ;
///    wxString    file_Name( folder_Appli.GetPath( wxPATH_GET_VOLUME | wxPATH_GET_SEPARATOR )
///                           + g_Recently_Used_Setting_List ) ;

    wxString  homeDir ;
    ::wxGetHomeDir( & homeDir );
    wxFileName  fileNam( homeDir + g_Recently_Used_Setting_List ) ;
    wxString    file_PathName  = fileNam.GetFullPath() ;
           //::wxLogDebug( wxT("Read_Setting_Data() : <%s>"), 
           //                                   (const wxChar *)file_PathName );
    short  cnt_Priority = Cnt_Ptr_Array( (const void **)RCL_Sort_Name ) ;

    wxFileInputStream  file_InStrm( file_PathName ) ;

    m_Cnt_Recent_Settings      =  0; 
    m_Cnt_Recent_Setting_Files =  0;

    if( ! file_InStrm.IsOk() )  return( -1 ) ;

    wxTextInputStream  txt_InStrm( file_InStrm, wxT("\t"), wxConvLocal ) ;

                    //::wxLogDebug( wxT("Read_Setting_Data(): name=<%s>"), (const wxChar *)file_PathName ) ;
    for( i = 0 ; i < cnt_Priority ; i ++ )
        sort_Priority_Lst[ i ] ;

    m_Recent_Settings_L[ 0 ].m_Opt_Auto_Diff_Chk = 0 ;

    is_Settings = 0 ;

    for( ; ; )
    {
        if( file_InStrm.Eof() )  break ;

        text = txt_InStrm.ReadLine() ;
                //::wxLogDebug( wxT("text= <%s>"), text.c_str() );

        if( text.IsEmpty() )  continue ;

        if( is_Settings )
        {
            ret = Interpret_SettingData( text, & m_Recent_Settings_L[ m_Cnt_Recent_Settings ] ) ;
            if( ret > 0 )
            {
                is_Settings |= ret ;

                continue ;
            }
        }

        //--------------

        nTkns = Subtract_String( text, wxT('%'), wxT(" >%: [%]"), 2, sub_Str, 0 );

                //::wxLogDebug( wxT("Read_Setting_Data() : nTkns = %d, sub_Str =<%s> <%s>"), nTkns, sub_Str[0].c_str(), sub_Str[1].c_str() );

        if( nTkns < 1 )  continue ;

        sub_Str[0].MakeUpper() ;

        if( sub_Str[0] == wxT("WINDOW_METRICS") )
        {
            if( (is_Settings & 0x13) == 0x13 )
            {
                m_Cnt_Recent_Settings ++ ;
                m_Recent_Settings_L[ m_Cnt_Recent_Settings ].Init() ; 
            }

            is_Settings = 0 ;

            if( nTkns < 2 )  continue ;

            ret = Subtract_String( sub_Str[1], wxT('%'), wxT(" %, %, %, %, %"), 5, tokn, 0 );

            for( i = 0 ; i < ret ; i ++ )
            {
                if( tokn[i].ToLong( & xl )  &&   xl >= 10 )
                    * parm[ i ] = xl ;
            }
        }
        else if( sub_Str[0] == wxT("SORT_PRIORITY") )
        {
            int  j ;
            long xa ;

            if( (is_Settings & 0x13) == 0x13 )
            {
                m_Cnt_Recent_Settings ++ ;
                m_Recent_Settings_L[ m_Cnt_Recent_Settings ].Init() ; 
            }

            is_Settings = 0 ;

            if( nTkns < 2 )  continue ;

            cnt_Prir = Subtract_String( sub_Str[1], wxT('%'), wxT(" %, %, %, %, %, %"), 6, tokn, 0 );
                        //::wxLogDebug( wxT("Priority: sub_Str[1] = <%s>"), sub_Str[1] );
            j = 0 ;
            for( i = 0 ; i < cnt_Prir ; i ++ )
            {               //::wxLogDebug( wxT("Priority: tokn[%d] = %s"), i, tokn[i] );
                if( tokn[i].ToLong( & xl ) )
                {
                    xa = abs( xl ) ;
                    if( 1 <= xa  &&  xa <= 6 )
                        sort_Priority_Lst[ j ++ ] = (short) xl ;
                }
            }
            sort_Priority_Lst[ j ] = 0 ;
        }
        else if( sub_Str[0] == wxT("SETTINGS") )
        {
            if( (is_Settings & 0x13) == 0x13 )
            {
                m_Cnt_Recent_Settings ++ ;
                m_Recent_Settings_L[ m_Cnt_Recent_Settings ].Init() ; 
            }

            is_Settings = 0 ;

            if( m_Cnt_Recent_Settings < Max_Recent_Settings() )
                is_Settings = 0x10 ;
        }
        else if( sub_Str[0] == wxT("SETTING_FILE") )
        {
            if( (is_Settings & 0x13) == 0x13 )
            {
                m_Cnt_Recent_Settings ++ ;
                m_Recent_Settings_L[ m_Cnt_Recent_Settings ].Init() ; 
            }

            is_Settings = 0 ;

            if( nTkns < 2 )  continue ;

            if(  sub_Str[ 1 ].IsEmpty() ) continue ;

            m_Recent_Setting_Files_L[ m_Cnt_Recent_Setting_Files ] =  sub_Str[ 1 ];

            m_Cnt_Recent_Setting_Files ++ ;
                    //::wxLogDebug( wxT("setting_file[%d] = <%s>"), m_Cnt_Recent_Setting_Files, (const wxChar *) sub_Str[ 1 ] );
        }
        else if( sub_Str[0] == wxT("END") )
        {
            break ;
        }
    }

    if( (is_Settings & 0x13) == 0x13 )  
        m_Cnt_Recent_Settings ++ ;

    is_Settings = 0 ;

  //={ /sort_Priority_Lst[] ǂ(1,2,3,4,5,6) check
  //      duplication & correct priority value check 
    for( i = 0 ; i < cnt_Priority ; i ++ ) 
        flg_Arry[ i ] = 0 ;

    for( i = 0 ; i < cnt_Priority ; i ++ )
    {
        x = abs( sort_Priority_Lst[ i ] );

        if( x <= 0 || cnt_Priority < x )
        {
            sort_Priority_Lst[ i ] = 0 ;  continue ;
        }

        if( flg_Arry[ x - 1 ] )
            sort_Priority_Lst[ i ] = 0 ;
        else
            flg_Arry[ x - 1 ] = 1 ;
    }

    //delete invalid priority element
    cnt = 0 ;
    for( i = 0 ; i < cnt_Priority ; i ++ )
    {
        if( sort_Priority_Lst[ i ] == 0 )  continue ;
        sort_Priority_Lst[ cnt ] = sort_Priority_Lst[ i ] ;
        cnt ++ ;
    }

    //}= /sort_Priority_Lst[]check ;
                    short * p = sort_Priority_Lst ;
                    ::wxLogDebug( wxT("Sort_Priority :Read End:  = %hd, %hd, %hd, %hd, %hd, %hd"),
                                    p[0], p[1], p[2], p[3], p[4], p[5], p[6]);
    sort_Priority_Lst[ cnt ] = 0 ;

#if 0  //debug out : Recent_Settings
        ::wxLogDebug( wxT("Recent_Settings= %d"), m_Cnt_Recent_Settings );

        for( i = 0 ; i < m_Cnt_Recent_Settings ; i ++ )
        {
            ::wxLogDebug( wxT("  %d :src_file=<%s>")  , i, m_Recent_Settings_L[ i ].m_Src_FileName );
            ::wxLogDebug( wxT("  %d :dst_file=<%s>\n"), i, m_Recent_Settings_L[ i ].m_Dst_FileName );
        }
#endif  //debug out : Recent_Settings

    return( 0 ) ;
}

//*****************************************************************************
//  C:\Documents and Settings\tanaka\Application Data\ToohuuDoo\Bkdf_Setting_File.Lst
//  ɕۑ
//*****************************************************************************

int
TopFRAME::Save_Setting_Data()
{
        short i, *p, diffChk_Cur ;
        int   x, y, w, h ;
        bool bRet, bRet1, bRet2 ;
        wxString data ;
        SettDATA  * pSetDat ;

    wxString  homeDir ;
    wxGetHomeDir( & homeDir );

    wxFileName   file( homeDir + g_Recently_Used_Setting_List ) ;

    wxString file_PathName  = file.GetFullPath() ;
           //::wxLogDebug( wxT("Save_Setting_Data() : <%s>"), 
           //                                      (const wxChar *)file_PathName );
    wxTextFile   txtFile( file_PathName );

    bRet = txtFile.Open( wxConvLocal ) ;   //wxTextFile  Open()  memory ɑSLoad ̂Œ
    if( ! bRet )
    {
        bRet1 = wxFileName::Mkdir( file.GetPath(), 0777, wxPATH_MKDIR_FULL ) ;
        if( ! bRet1 )           return( -1 );

        bRet2 = txtFile.Create() ;
        if( ! bRet2 )           return( -1 );
    }
            //::wxLogDebug( wxT("Save_Setting_Data(): bRet=%d, %d: name=<%s>"), 
            //                                     bRet, bRet1, (const wxChar *)file_PathName ) ;
    txtFile.Clear() ;

    //---------

    if( ! IsIconized() )
    {
        GetPosition( & x, & y ) ;
        GetSize( & w, & h );

        data = wxString::Format( wxT(">Window_Metrics: [%d, %d, %d, %d, %d]"), 
                               x, y, w, h, m_SplitWin->GetSashPosition() );
        txtFile.AddLine( data  );
    }

    //================== output sort-priority of tree listings 

    p = m_DTreeCtrl->m_SortPrior_Tbl.m_Priority_Lst ;
    data = wxString::Format( wxT(">Sort_Priority:  [%hd, %hd, %hd, %hd, %hd, %hd]"),
                                    p[0], p[1], p[2], p[3], p[4], p[5], p[6] );
    txtFile.AddLine( data  );

    //================== output Setting files

    for( i = 0 ; i < m_Cnt_Recent_Setting_Files ; i ++ )
    {
        data = wxT(">Setting_File: [") + m_Recent_Setting_Files_L[ i ] + wxString( wxT("]") ) ;
        txtFile.AddLine( data  );
                    //::wxLogDebug( wxT("Save_Setting_Data() [%d] = %s"), i, (const wxChar *) data );
    }

    //================== output Settings

    diffChk_Cur = 0 ;

    if( m_DTreeCtrl->m_pRoot_Node->m_Is_Valid_L[0]  &&  m_DTreeCtrl->m_pRoot_Node->m_Is_Valid_L[1] )
    {
        txtFile.AddLine( wxT(">Settings:") );

        data = wxT("  .Source       [") + m_DTreeCtrl->m_pRoot_Node->m_Name_L[0] + wxT("]") ;
        txtFile.AddLine(  data   );
                    ::wxLogDebug( wxT("Save_Settings() :%s"), (const wxChar *) data );

        data = wxT("  .Destination  [") + m_DTreeCtrl->m_pRoot_Node->m_Name_L[1] + wxT("]") ;
        txtFile.AddLine(  data   );
                    ::wxLogDebug( wxT("Save_Settings() :%s"), (const wxChar *) data );

        diffChk_Cur = -1 ;
        if( m_DiffChkBtn->GetValue() ) diffChk_Cur = 1 ;

        data = wxT("  .Auto_Diff_Check = ")  ;

        if( diffChk_Cur >= 0 )  data += wxT("On") ;
        else                    data += wxT("Off") ;
        txtFile.AddLine( data  );
                    ::wxLogDebug( wxT("Save_Settings() :%s"), (const wxChar *) data );
    }

    for( i = 0 ; i < m_Cnt_Recent_Settings ; i ++ )
    {
        pSetDat = & m_Recent_Settings_L[i] ;

        if( pSetDat->m_Src_FileName == m_DTreeCtrl->m_pRoot_Node->m_Name_L[0]  &&
            pSetDat->m_Dst_FileName == m_DTreeCtrl->m_pRoot_Node->m_Name_L[1]  &&
            pSetDat->m_Opt_Auto_Diff_Chk == diffChk_Cur
          )
            continue ;

        txtFile.AddLine( wxT(">Settings:") );

        data = wxT("  .Source       [") + pSetDat->m_Src_FileName + wxT("]") ;
        txtFile.AddLine( data  );
                    ::wxLogDebug( wxT("Save_Settings() [%d] = %s"), i, (const wxChar *) data );
        data = wxT("  .Destination  [") + pSetDat->m_Dst_FileName + wxT("]") ;
        txtFile.AddLine( data  );
                    ::wxLogDebug( wxT("Save_Settings() [%d] = %s"), i, (const wxChar *) data );

        data = wxT("  .Auto_Diff_Check = ") ;
        if( pSetDat->m_Opt_Auto_Diff_Chk )  data += wxT("On") ;
        else                                data += wxT("Off") ;
        txtFile.AddLine( data  );
                    ::wxLogDebug( wxT("Save_Settings() [%d] = %s"), i, (const wxChar *) data );
    }

    txtFile.AddLine( wxT(">End:") );

    txtFile.Write( wxTextFileType_None, wxConvLocal );//ۂɃt@Cɏ

    return( 0 ) ;
}

//*****************************************************************************
//
//*****************************************************************************

int 
TopFRAME::Read_SettingFile( const wxString & setting_FileName ) 
{
    extern wxString Str_Trim_X( const wxString & a ) ;
//    wxStringTokenizer tokens, tknsr_1 ;
    SettDATA  setData ;
    wxString text, tkn, sub_Str[4] ;
    bool flag ;
    int  ret, ret_1 ;

    ::wxLogDebug( wxT( "Read_SettingFile( %s )" ), (const wxChar *)setting_FileName ) ;

    wxFileInputStream  file_InStrm( setting_FileName ) ;

    if( ! file_InStrm.IsOk() )  return( -1 ) ;

    wxTextInputStream  txt_InStrm( file_InStrm ) ;

//>SOURCE  >Destination  sT

    for( int i = 0 ; ; i ++ )
    {
        if( file_InStrm.Eof() ) break ;

        text = txt_InStrm.ReadLine() ;

        if( text.IsEmpty() ) continue ;

        text.Trim( false ) ;

        ret = Interpret_SettingData( text, & setData ) ;
        if( ret == 1 )
        {
            ret_1 = Open_RootFolder_OneSide( setData.m_Src_FileName, 0 );
        }
        else if( ret == 2 )
        {
            ret_1 = Open_RootFolder_OneSide( setData.m_Dst_FileName, 1 );
        }
        else if( ret == 4 )
        {
            flag = false ;

            if( setData.m_Opt_Auto_Diff_Chk > 0 )
                flag = true ;
            m_DiffChkBtn->SetValue( flag ) ;
        }
        else if( ret == 8 )
        {
            m_Opt_Auto_Backup = setData.m_Opt_Auto_Diff_Chk ;
        }
    }

    return( 0 ) ;
}

//*****************************************************************************
//
//*****************************************************************************

int 
TopFRAME::Save_SettingFile( const wxString & setting_FileName )
{
///    wxStringTokenizer tokens, tknsr_1 ;
    wxString text, tkn, onOff, sub_Str[3] ;  
//    int  ret ;

    wxFileOutputStream  file_OutStrm( setting_FileName ) ;
           //::wxLogDebug( wxT( "Save_SettingFile( %s ) ret= %d" ), (const wxChar *)setting_FileName, file_OutStrm.IsOk() ) ;

    if( ! file_OutStrm.IsOk() )  return( -1 ) ;

    wxTextOutputStream  outStrm( file_OutStrm ) ;

    outStrm << wxT(".Source       [") << m_DTreeCtrl->m_pRoot_Node->m_Name_L[ 0 ] << wxT("];\n") ;
    outStrm << wxT(".Destination  [") << m_DTreeCtrl->m_pRoot_Node->m_Name_L[ 1 ] << wxT("];\n") ;

    onOff = wxT("OFF") ;
    if( m_DiffChkBtn->GetValue() )  onOff = wxT("ON") ;

    outStrm << wxT(".Auto_Diff_Check = ") << onOff << wxT(" ;\n") ;
    outStrm << wxT("//>Auto_Backup;\n") ;

    return( 0 ) ;
}

//*****************************************************************************
//
//*****************************************************************************
static
int
Interpret_SettingData
(
    const wxString & inText,
    SettDATA         * setData   //<out>
)
{
        wxString  sub_Str[4] ;  
        INT_8     typ_SubStr[4] ;
        int       ret ;

    ret = StrToken_Breaker( inText, wxT(";"), 4, sub_Str, typ_SubStr ) ;

    if( ret < 2 )   return( 0 ) ;

    if( typ_SubStr[0] != 0 )   return( 0 ) ;

    sub_Str[0].MakeUpper() ;

    if( sub_Str[0] == wxT(".SOURCE") )
    {
        setData->m_Src_FileName = sub_Str[1] ;
        return( 1 ) ;
    }

    if( sub_Str[0] == wxT(".DESTINATION") )
    {
        setData->m_Dst_FileName = sub_Str[1] ; 
        return( 2 ) ;
    }

    sub_Str[2].MakeUpper() ; //sub_Str[1] == "=" ł邾낤

    if( sub_Str[0] == wxT(".AUTO_DIFF_CHECK") )
    {
        setData->m_Opt_Auto_Diff_Chk = 0 ; 
        if(      sub_Str[2] == wxT("ON") )  setData->m_Opt_Auto_Diff_Chk = 1 ;
        else if( sub_Str[2] == wxT("OFF") ) setData->m_Opt_Auto_Diff_Chk = -1 ;

        return( 4 ) ;
    }

    if( sub_Str[0] == wxT(".AUTO_BACKUP") )
    {
        setData->m_Opt_Auto_Backup = 0 ;
        if(      sub_Str[2] == wxT("ON") )  setData->m_Opt_Auto_Backup = 1 ;
        else if( sub_Str[2] == wxT("OFF") ) setData->m_Opt_Auto_Backup = -1 ;

        return( 8 ) ;
    }

    return( 0 ) ;
}
