//#include  <stdlib.h>
//#include  "wx/wx.h"
//#include  "wx/filename.h"
#include  <wx/dc.h>
#include  <wx/dcclient.h>
#include  <wx/log.h>
#include  "DualTree_Ctl.h"
#include  "TopFrame.h"
#include  "My_Menu.h"
#include  "MyThread.h"

//*****************************************************************************
//
//*****************************************************************************

void
DualTree_CTL::OnDraw( wxDC & dc )
{
        int  x, y, h;
        int  xUnit, yUnit, height ;

        //**/    ::wxLogDebug( wxT("DualTree_CTL::OnDraw() enter") );
    GetScrollPixelsPerUnit( & xUnit, & yUnit ) ;

    GetViewStart( & x, & y ) ;

    m_Y1_View = yUnit * y ;

    GetClientSize( & x, & h ) ;

    m_Y2_View = m_Y1_View + h ;

///    m_Cnt_Item_DrawInf = 0 ;

///    m_Idx_IRect_Cursor = -1 ;

//    dc.DestroyClippingRegion() ;
//    dc.SetBackground( m_Brush_Default );
//    dc.Clear() ;

    m_pDC = & dc ;

    m_pDC->SetFont( GetFont() );

    //Draw_Node_Item( & m_Root_Node, zRect, & zRect ) ;

    //Set_DrawInf_Children( m_pRoot_Node, m_zPos_Top, true, & height ) ;
    Set_DrawInfo( true, & height ) ;

    for( short ii = 0 ; ii < m_Cnt_Item_DrawInf ; ii ++ )
    {
        Draw_Item( m_pArry_Item_DrawInf[ ii ] ) ;
    }

    SetVirtualSize( 1000, height + 50 ) ;

//    qsort( m_pArry_Item_DrawInf, m_Cnt_Item_DrawInf, 
//              sizeof( *m_pArry_Item_DrawInf ), cmp_y_client );

                  // ::wxLogDebug( "DualTree_CTL::OnDraw() : m_Cnt_Item_DrawInf = %hd", m_Cnt_Item_DrawInf );
        //**/for( short i = 0 ; i < m_Cnt_Item_DrawInf ; i ++ )
        //**/    ::wxLogDebug( "ItemRect[%hd].y =%d", i, m_pArry_Item_DrawInf[i].iRect.GetTop() );
        //**/    ::wxLogDebug( wxT("DualTree_CTL::OnDraw() exit") );
    return ;
}

//*****************************************************************************
//
//*****************************************************************************

void
DualTree_CTL::OnMouseMotion( wxMouseEvent & event )
{
    wxPoint  pos_Cli, pos ; ;
    wxBrush  brush = wxNullBrush ;
    Item_DrawINFO   drawInf_Cursor_Old ;
    Item_DrawINFO * pDrawInf ;
    int  w_Cli, h_Cli ;
    int  y_Cursor_G ;
//    int  cw, ch ;
    short ii ;

    pos_Cli = event.GetPosition() ;

    CalcUnscrolledPosition( pos_Cli.x, pos_Cli.y, & pos.x, & pos.y ) ;//scrolled position 

    y_Cursor_G = pos.y ;
           //::wxLogDebug( "OnMouseMotion() : y_Cursor_G= %d", y_Cursor_G );

    GetClientSize( & w_Cli, & h_Cli ) ;

    if( ( pos_Cli.x < m_Offset_X ) || ( w_Cli - Band_Cursor_Select < pos_Cli.x ) )
    {           //The Cursor is in the Main-area, --> show cross-cursor
        SetCursor( *wxCROSS_CURSOR );//WIndows ł́AResource-file(Bacup_Diff.RC) ȂƓȂ
    }
    else
    {           //The Cursor out of the Main-area, --> show default-cursor
        SetCursor( wxNullCursor );
    }

    //=======================
    //  search item for the cursor y-position
    for( ii = 0 ; ; ii ++ )
    {
        if( ii >= m_Cnt_Item_DrawInf )      return ; //not found ******************

        pos = m_pArry_Item_DrawInf[ ii ].m_position ;
        if( y_Cursor_G < pos.y     )  continue ; 
        if( y_Cursor_G > pos.y + Height_Item( m_pArry_Item_DrawInf[ii] ) ) continue ; 
            break ;
    }

    //found -->m_pArry_Item_DrawInf[ ii ]

    pDrawInf = & m_pArry_Item_DrawInf[ ii ] ;

    if( pDrawInf->m_pItemBase == m_pRoot_Node->m_DrawInf_Cursor.m_pItemBase ) 
        return ; //݂ cursor item Ɠ --> `KvȂ

    wxClientDC  dc( this ) ;

    DoPrepareDC(dc) ;

    dc.SetFont( GetFont() );

    m_pDC = & dc ;

    drawInf_Cursor_Old = m_pRoot_Node->m_DrawInf_Cursor ;

    m_pRoot_Node->m_DrawInf_Cursor = * pDrawInf ;

    if( drawInf_Cursor_Old.m_pItemBase )
    {       // X̃J[\ʒuItem `Ȃ(J[\\)
        Draw_Item( drawInf_Cursor_Old );
    }

    Draw_Item( m_pRoot_Node->m_DrawInf_Cursor );//V cursor ʒuitem `Ȃ

    wxCommandEvent eventCustom( EVTYP_Item_OnCursor, GetId() );//GetId() ͌ĂȂ
             
    eventCustom.SetClientData( & m_pRoot_Node->m_DrawInf_Cursor ) ;

    ::wxPostEvent( m_Frame, eventCustom );
               //::wxLogDebug( wxT("OnMouseMotion() Exit:") );
}

//*****************************************************************************
// y_Cursor ǂ item sɂ邩ׂ
//*****************************************************************************

Item_DrawINFO *
DualTree_CTL::Get_Item_Y_Pos
( 
    int    y_Cursor,
    int  * pIdx_DrInf   //<out>
)  const
{
    int  ii ;
    wxPoint  pos_Itm ;

    for( ii = 0 ; ; ii ++ )
    {
        if( ii >= m_Cnt_Item_DrawInf )
        {
            if( pIdx_DrInf ) * pIdx_DrInf = -1 ;
            return( 0 ) ;
        }

        pos_Itm = m_pArry_Item_DrawInf[ ii ].m_position ;

        if( y_Cursor < pos_Itm.y   )  continue ; 
        if( y_Cursor > pos_Itm.y + Height_Item( m_pArry_Item_DrawInf[ ii ] ) ) continue ; 
            break ;//  --> m_pArry_Item_DrawInf[ ii ]
    }

    if( pIdx_DrInf )
        * pIdx_DrInf = ii ;

    return( & m_pArry_Item_DrawInf[ ii ] ) ;
}

//*****************************************************************************
//
//*****************************************************************************

void
DualTree_CTL::OnLMouseDown( wxMouseEvent & event )
{
    wxPoint pos_Clk_Cli ; //Click position in window-client 
    wxPoint pos_Clk     ; //Click position in scrolling space 
    wxPoint pos       ; //work 
    Item_DrawINFO * pDrawInf ;
    MyThread_BASE * pThread ;

    DualTreeBASE_ITEM * pItem ;
    DualTreeCtl_NODE    * pNod ;
    DualTreeCtl_ITEM    * pCDat ;
    wxRect  rect ;
    int  y_Cursor_G, ii ;
    int  w_Cli, h_Cli ;
    int  ret0, ret1 ;

    SetFocus() ;

    GetClientSize( & w_Cli, & h_Cli ) ;

    pos_Clk_Cli = event.GetPosition() ;

    CalcUnscrolledPosition( pos_Clk_Cli.x, pos_Clk_Cli.y, & pos_Clk.x, & pos_Clk.y ) ;// 

    y_Cursor_G = pos_Clk.y ;

                ::wxLogDebug( wxT("OnLMouseDown() : pos_Clk = %d, %d"), pos_Clk.x, pos_Clk.y );

    pDrawInf = Get_Item_Y_Pos( pos_Clk.y, & ii ) ;// mouse-point ǂ item sɂ邩ׂ

    if( pDrawInf == 0 )  return ;

    pItem = pDrawInf->m_pItemBase ;

    pCDat = (DualTreeCtl_ITEM *) pItem->m_pCustomData ;

                ::wxLogDebug( wxT("OnLMouseDown() : Hit : 0 :i_State= $%hX"), pCDat->i_State );

    wxRect rect_Sym( pDrawInf->m_position.x, pDrawInf->m_position.y,
                      X_Size_Item( pItem ), Height_Item( *pDrawInf ) ) ;

    if( rect_Sym.Contains( pos_Clk ) )
    {         // symbol  _ click ꂽ.  
        Get_Chk_Btn_Rect( rect_Sym, & rect ) ;

        if( rect.Contains( pos_Clk ) )
        {        //= { toggle st_BACKUP_OPT-bit. Backup Ώ check box
            int opt = pCDat->Backup_Option() ;

            pCDat->Set_Backup_Option( ( opt + 1 ) % 2 );

                ::wxLogDebug( wxT("OnLMouseDown() : Hit st_BACKUP_OPT") );
        }
        else
        {        //={ toggle Tree st_EXPANDED-bit . Node 
            if( ! pItem->Is_Node() )  return ;

            pNod = (DualTreeCtl_NODE *) pItem ;

            if( pCDat->Is_Expanded() == 0 )
                pCDat->i_State |= DualTreeCtl_ITEM::st_EXPANDED ;  //Node half opened view state
            else
                pCDat->i_State &= ~DualTreeCtl_ITEM::st_EXPANDED_M ;  //Node closed view state

///            Update() ;//invalid region ݂鎞̂݁A`悳  Asyncronous
///            Refresh() ;//invalid region Ɋւ邱ƂȂ `悷Basyncronous
            {
            wxClientDC  dc( this ) ;
            DoPrepareDC( dc ) ;
            OnDraw( dc ) ;
            }

            ret0 = ret1 = -1 ;

            if( m_Frame->m_Idx_Thread_Work >= 0 )
            {      // DIff_Chk_Thread Ă΁AE
                pThread = m_Frame->m_Thread_L[ m_Frame->m_Idx_Thread_Work ] ;
                if( pThread->m_Type == MyThread_BASE::T_DiffChek )
                    pThread->m_GoOn_Flag = 0 ;
            }

            if( pNod->m_State_Load_L[ 0 ] != 1 )
            {
                ret0 = pNod->Begin_Load_Children( m_SortPrior_Tbl, 0 );
            }

            if( pNod->m_State_Load_L[ 1 ] != 1 )
            {
                ret1 = pNod->Begin_Load_Children( m_SortPrior_Tbl, 1 );
            }

            m_Frame->KickOff_Diff_Check() ;

            //-{100//  i_State flag {̂̂ɂ
            if( pCDat->i_State & DualTreeCtl_ITEM::st_EXPANDED_M )
                pCDat->i_State |= DualTreeCtl_ITEM::st_EXPANDED_M ; //Node opened view state
            //-}100
            if( pNod->m_Is_Valid_L[0] != 1 )     goto EXIT_Refresh ;
            if( pNod->m_Is_Valid_L[1] != 1 )     goto EXIT_Refresh ;
        }
    }
    else if( pos_Clk_Cli.x > w_Cli - Band_Cursor_Select )
    {         //symbol O̓ ̓_ click ꂽ --> I
                ::wxLogDebug( wxT("Select clicked") );
        long  state_Old ;
        state_Old = pCDat->i_State & DualTreeCtl_ITEM::st_SELECTED ;

        if( ::wxGetKeyState( WXK_SHIFT ) )
        {
            pCDat->i_State ^= DualTreeCtl_ITEM::st_SELECTED ;//inverse=toggle
        }
        else
        {       //click without shift-key --> S I --> toggle clicked-item 
            m_pRoot_Node->Set_State_All( DualTreeCtl_ITEM::st_SELECTED, 0 ) ;
            pCDat->i_State |= (~state_Old) & DualTreeCtl_ITEM::st_SELECTED;
        }
///        m_pDrawInf_Selecting = pDrawInf ;

///        m_Timer.SetOwner( this ) ;
///        m_Timer.Start( 1000 ) ;
    }
    else if( pos_Clk_Cli.x < m_Offset_X )
    {      // ܂܂Ăchilren Bem[h Chilren  collapse
        pNod = (DualTreeCtl_NODE *) pItem->m_pMother_L[0] ;
        if( pNod == 0 )
            pNod = (DualTreeCtl_NODE *) pItem->m_pMother_L[1] ;
        if( pNod == 0 )
            return ;

        pNod->i_State &= ~DualTreeCtl_ITEM::st_EXPANDED_M ;//--> closed state

        Scroll_Item_Visible( pNod, pos_Clk_Cli.y ) ;
    }
    else
    {         ::wxLogDebug( wxT("OnLMouseDown()-End : No-Hit") );
        return ;
    }
                ::wxLogDebug( wxT("OnLMouseDown() : Hit : 1 : i_State= $%hX"), pCDat->i_State );

 EXIT_Refresh :

    m_pRoot_Node->m_DrawInf_Cursor.m_pItemBase = 0 ;//maybe no need
    m_Cnt_Item_DrawInf = 0 ;//may be not needed

    Refresh() ;
}

//*****************************************************************************
//
//*****************************************************************************

void
DualTree_CTL::OnLDoubleClick( wxMouseEvent & event )
{
    OnLMouseDown( event ) ;
}

//*****************************************************************************
//
//*****************************************************************************

void
DualTree_CTL::OnRMouseDown( wxMouseEvent & event )
{
    extern wxChar   RC_Menu_Chk_NodeAll[] ;
    extern wxChar   RC_Menu_UnChk_NodeAll[] ;

    wxPoint pos_Clk_Cli ; //Click position in window-client 
    wxPoint pos_Clk     ; //Click position in scrolling space 
    Item_DrawINFO * pDrawInf ;
    int  to_Disable, ii;

    pos_Clk_Cli = event.GetPosition() ;

    CalcUnscrolledPosition( pos_Clk_Cli.x, pos_Clk_Cli.y, & pos_Clk.x, & pos_Clk.y ) ;// 

    ::wxLogDebug( wxT("OnRMouseDown() : %d, %d"), pos_Clk_Cli.x, pos_Clk_Cli.y );

    pDrawInf = Get_Item_Y_Pos( pos_Clk.y, & ii ) ;// mouse-point ǂ item sɂ邩ׂ

    to_Disable = m_Frame->Is_Doing_Backup() ;

    if( pDrawInf )
    {
        m_pItem_R_Clked = pDrawInf->m_pItemBase ;

        if( ! m_pItem_R_Clked->Is_Node() )
            to_Disable = 1 ;
    }
    else
    {
        to_Disable = 1 ;
    }

    My_MENU  menu( to_Disable ) ;

    menu.Append_X( menu_ID_BackUp_Chk_NodeAll, 
                                         RC_Menu_Chk_NodeAll );
    menu.Append_X( menu_ID_BackUp_UnChk_NodeAll, 
                                         RC_Menu_UnChk_NodeAll );
    PopupMenu( & menu, pos_Clk_Cli.x, pos_Clk_Cli.y );

    event.Skip( false ) ;

    return ;
}

//*****************************************************************************
//  not needed.
//*****************************************************************************

void
DualTree_CTL::OnLMouseUp( wxMouseEvent & event )
{
//    ::wxLogDebug( wxT("DualTree_CTL::OnLMouseUp() m_pDrawInf_Selecting= %p"), 
//            m_pDrawInf_Selecting );

//    if( m_pDrawInf_Selecting == 0 )  return ;

//    if( m_Timer.IsRunning() )
//    {    // quick click
//        m_Timer.Stop() ;

//        m_pRoot_Node->Set_State_All( DualTreeCtl_ITEM::st_SELECTED, 0 ) ;

//        if( ::wxGetKeyState( WXK_SHIFT ) )
//        {
//        }
//        else
//        {
//       }
//    }

//    m_pDrawInf_Selecting = 0 ;
}

//*****************************************************************************
//
//*****************************************************************************

void
DualTree_CTL::OnMouseWheel( wxMouseEvent & event )
{
    event.Skip( true ) ;
}

//*****************************************************************************
// ͎ۂ scroll `̑OɌĂ΂
//*****************************************************************************

void
DualTree_CTL::OnScroll( wxScrollWinEvent & event )
{
        //::wxLogDebug( wxT("DualTree_CTL::OnScroll") ) ;
        Item_DrawINFO drawInf ;

    if( m_pRoot_Node->m_DrawInf_Cursor.m_pItemBase )
    {       //redraw current cursor-item without cursor indication
        wxClientDC  dc( this ) ;

        DoPrepareDC(dc) ;

        dc.SetFont( GetFont() );

        m_pDC = & dc ;

        drawInf = m_pRoot_Node->m_DrawInf_Cursor ;

        m_pRoot_Node->m_DrawInf_Cursor.m_pItemBase = 0 ;

        Draw_Item( drawInf ) ;
    }

    wxCommandEvent eventCustom( EVTYP_Item_OnCursor, GetId() );//GetId() ͌ĂȂ

    eventCustom.SetClientData( & m_pRoot_Node->m_DrawInf_Cursor ) ;

    ::wxPostEvent( m_Frame, eventCustom );

//    Refresh() ;

    event.Skip();

    return ;
}

//*****************************************************************************
//
//*****************************************************************************

void
DualTree_CTL::OnBackUp_Chk_NodeAll(wxCommandEvent& WXUNUSED(event))
{
    if( m_pItem_R_Clked == 0 )            return ;//Iږ

            ::wxLogDebug( wxT("      m_pItem_R_Clked=( [%s] [%s], ?node=%d"), m_pItem_R_Clked->m_Name_L[0],  m_pItem_R_Clked->m_Name_L[0], m_pItem_R_Clked->Is_Node() );

    if( ! m_pItem_R_Clked->Is_Node() )    return ;//Iڂ Folder łȂ

    ((DualTreeCtl_NODE *)m_pItem_R_Clked)->Set_BackupOpt_Children( 1 ) ;

    Refresh() ;
}

//*****************************************************************************
//
//*****************************************************************************

void
DualTree_CTL::OnBackUp_UnChk_NodeAll(wxCommandEvent& WXUNUSED(event))
{
    if( m_pItem_R_Clked == 0 )            return ;//Iږ

            ::wxLogDebug( wxT("      m_pItem_R_Clked=( [%s] [%s], ?node=%d"), m_pItem_R_Clked->m_Name_L[0],  m_pItem_R_Clked->m_Name_L[0], m_pItem_R_Clked->Is_Node() );

    if( ! m_pItem_R_Clked->Is_Node() )    return ;//Iڂ Folder łȂ

    ((DualTreeCtl_NODE *)m_pItem_R_Clked)->Set_BackupOpt_Children( 0 ) ;

    Refresh() ;
}

//*****************************************************************************
// obsolete
//*****************************************************************************

void 
DualTree_CTL::OnTimerEvent( wxTimerEvent & event )
{
    ::wxLogDebug( wxT("DualTree_CTL::OnTimerEvent") );

    m_pDrawInf_Selecting = 0 ;
}

//*****************************************************************************
// obsolete
//*****************************************************************************

//void
//DualTree_CTL::OnMouseMotion( wxMouseEvent & event )
//{
//    wxRect * pRect ;
//    wxBrush  brush = wxNullBrush ;
//    Item_DrawINFO * pDrawInf ;
//    int  xx, yy ; 
//    int  cw, ch, y_Cursor_G ;
//    short ii ;

//    y_Cursor_G = event.GetPosition().y ;
//           ::wxLogDebug( "OnMouseMotion() : y_Cursor_G= %d", y_Cursor_G );

//    for( ii = 0 ; ; ii ++ )
//    {
//        if( ii >= m_Cnt_Item_DrawInf )  return ;

//        pRect = & m_pArry_Item_DrawInf[ ii ].iRect ;
//        if( y_Cursor_G < pRect->GetTop()    )  continue ; 
//        if( y_Cursor_G > pRect->GetBottom() )  continue ; 
//            break ;
//    }

//    if( ii == m_Idx_IRect_Cursor )  return ;

//    wxClientDC  dc( this ) ;//́Â܂܂ƁAscrolled coordinate ɑΉȂ
                            //  {A  DoPrepareDC(dc);  KvAł͕KvȂ
//    brush.SetStyle( wxTRANSPARENT );
//    dc.SetBrush( brush );
//    dc.SetPen( * wxLIGHT_GREY_PEN ) ;
//    dc.SetLogicalFunction( wxINVERT ) ;

//    GetClientSize( & cw, & ch ) ;

//    if( m_Idx_IRect_Cursor >= 0 )
//    {
//        pDrawInf = & m_pArry_Item_DrawInf[ m_Idx_IRect_Cursor ] ;

//        dc.DrawRectangle( 2, pDrawInf->iRect.y - 1, cw, pDrawInf->iRect.height );
//        CalcUnscrolledPosition( 2, pDrawInf->iRect.y - 1, & xx, & yy ) ;
//        dc.DrawRectangle( xx, yy, cw, pDrawInf->iRect.height );  //DoPrepareDC(dc);΂
 //   }

//    m_Idx_IRect_Cursor = ii ;

//    pDrawInf = & m_pArry_Item_DrawInf[ m_Idx_IRect_Cursor ] ;

//    dc.DrawRectangle( 2, pDrawInf->iRect.y - 1, cw, pDrawInf->iRect.height );
//    CalcUnscrolledPosition( 2, pDrawInf->iRect.y - 1, & xx, & yy ) ;
//    dc.DrawRectangle( xx, yy, cw, pDrawInf->iRect.height );  //DoPrepareDC(dc);΂
    
               //::wxLogDebug( "y= %d -> %d : %s", pDrawInf->iRect.y - 1, yy, (const wxChar *)pDrawInf->pItem->m_Name_L[0] );
//}
