#include  "Dlg_CTime_DeadBand.h"

BEGIN_EVENT_TABLE( Dlg_CTime_DeadBAND, Dlg_CTime_DeadBAND_0 )
    EVT_BUTTON( wxID_SET, Dlg_CTime_DeadBAND::On_BTN_Set )
    EVT_BUTTON( wxID_OK , Dlg_CTime_DeadBAND::On_BTN_Ok )
    EVT_BUTTON( wxID_CANCEL , Dlg_CTime_DeadBAND::On_BTN_Cancel )
END_EVENT_TABLE()


//===================================================================
//
//===================================================================

Dlg_CTime_DeadBAND::Dlg_CTime_DeadBAND( wxWindow * parent, time_t cTime_DeadBand ) 
    : Dlg_CTime_DeadBAND_0( parent ) 
{
    m_CTime_DeadBand = cTime_DeadBand ;

    wxString  s ;

    s.Printf( wxT("%d"), (int)cTime_DeadBand ) ;

    m_TCTL_DeadBand_New->SetValue( s ) ;
    m_TCTL_DeadBand_Old->SetValue( s ) ;
}

//===================================================================
//
//===================================================================
void
Dlg_CTime_DeadBAND::On_BTN_Set( wxCommandEvent & event )
{
    wxString  s ;
    long v ;
    bool bRet ;

    s = m_TCTL_DeadBand_New->GetValue() ;
    bRet = s.ToLong( & v ) ;

    if( bRet &&  v >= 0 )
    {
        m_CTime_DeadBand = v ;

        s.Printf( wxT("%d"), (int)m_CTime_DeadBand ) ;

        m_TCTL_DeadBand_New->SetValue( s ) ;
        m_TCTL_DeadBand_Old->SetValue( s ) ;

        return ;
    }

    s.Printf( wxT("%d"), (int)m_CTime_DeadBand ) ;

    m_TCTL_DeadBand_New->SetValue( s ) ;
}

//===================================================================
//
//===================================================================
void
Dlg_CTime_DeadBAND::On_BTN_Ok( wxCommandEvent & event )
{
    EndModal( 0 ) ;
}

//===================================================================
//
//===================================================================
void
Dlg_CTime_DeadBAND::On_BTN_Cancel( wxCommandEvent & event )
{
    EndModal( 1 ) ;
}

