#include  "Dlg_Set_Preference.h"

BEGIN_EVENT_TABLE( Set_Preference_DLG, Set_Preference_DLG_0 )
    EVT_BUTTON( BtnID_Close , Set_Preference_DLG::On_BTN_Close )
    EVT_BUTTON( BtnID_Discard , Set_Preference_DLG::On_BTN_Discard )
    EVT_BUTTON( BtnID_SET_DeadBand, Set_Preference_DLG::On_BTN_Set_DeadBand )
    EVT_BUTTON( BtnID_Restore_DeadBand , Set_Preference_DLG::On_BTN_Restore_DeadBand )
END_EVENT_TABLE()

//===================================================================
//
//===================================================================

Set_Preference_DLG::Set_Preference_DLG
(
    wxWindow * parent, time_t cTime_DeadBand, 
    bool  isCaseSensitive 
)    : Set_Preference_DLG_0( parent ) 
{
    int n ;

    m_CTime_DeadBand_0  = cTime_DeadBand ;
    m_CTime_DeadBand    = cTime_DeadBand ;
    m_isCaseSensitive   = isCaseSensitive ;

    wxString  s ;

    s.Printf( wxT("%d"), (int)cTime_DeadBand ) ;

    m_TCTL_DeadBand_New->SetValue( s ) ;
    m_TCTL_DeadBand_Old->SetValue( s ) ;
    n = 1 ;
    if( isCaseSensitive )
        n = 0 ;
    m_RadioBox_CCase_FileName->SetSelection( n );
}

//===================================================================
//
//===================================================================
void
Set_Preference_DLG::On_BTN_Set_DeadBand( wxCommandEvent & event )
{
    wxString  s ;
    long v ;
    bool bRet ;

    s = m_TCTL_DeadBand_New->GetValue() ;
    bRet = s.ToLong( & v ) ;

    if( bRet &&  v >= 0 )
    {
        m_CTime_DeadBand = v ;

        s.Printf( wxT("%d"), (int)m_CTime_DeadBand ) ;

        m_TCTL_DeadBand_New->SetValue( s ) ;
        m_TCTL_DeadBand_Old->SetValue( s ) ;

        return ;
    }

    s.Printf( wxT("%d"), (int)m_CTime_DeadBand ) ;

    m_TCTL_DeadBand_New->SetValue( s ) ;
    m_TCTL_DeadBand_Old->SetValue( s ) ;
}

//===================================================================
//
//===================================================================
void
Set_Preference_DLG::On_BTN_Restore_DeadBand( wxCommandEvent & event )
{
    wxString  s ;

    m_CTime_DeadBand = m_CTime_DeadBand_0 ;

    s.Printf( wxT("%d"), (int)m_CTime_DeadBand ) ;

    m_TCTL_DeadBand_New->SetValue( s ) ;
    m_TCTL_DeadBand_Old->SetValue( s ) ;
}

//===================================================================
//
//===================================================================
void
Set_Preference_DLG::On_BTN_Close( wxCommandEvent & event )
{
        int n;

    n = m_RadioBox_CCase_FileName->GetSelection();

    m_isCaseSensitive = false ;
    if( n == 0)
        m_isCaseSensitive = true ;

    EndModal( 0 ) ;
}

//===================================================================
//
//===================================================================
void
Set_Preference_DLG::On_BTN_Discard( wxCommandEvent & event )
{
    m_CTime_DeadBand = m_CTime_DeadBand_0 ;

    EndModal( 1 ) ;
}
