#include <wx/gdicmn.h>
#include <wx/window.h>

///%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//
///%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

class File_Info_CTL : public wxWindow
{
  public :
    //constant
    short   q_Alignment     ; //=0--> right align
    short   q_VLen_FSize    ; //file size view field length
    short   q_VLen_DateTime ;//time-stamp view field length

    //contents
    short        q_Is_Valid ;
    wxString     q_Path_Str ;
    wxULongLong  q_Data_Size ;
    wxDateTime   q_Upd_Date  ; //update time stamp 

    File_Info_CTL( wxWindow * parent, int wid ) ;

    void  Reset();

    void  Set( short is_Valid, const wxString * path, 
                   const wxULongLong * pData_Size, 
                   const wxDateTime  * pUpd_Date       ) ;
    void  OnPaint( wxPaintEvent & event );
    void  OnSize( wxSizeEvent& event );

    DECLARE_EVENT_TABLE()
};
