#include  <wx/string.h>
#include  <wx/dir.h>

#ifndef MY_DIR_INCLUDE
#define MY_DIR_INCLUDE

//#############################################################################
//
//#############################################################################

class My_DirEnumerator
{
  public :

	virtual int OnFile( const wxString & filName ) = 0 ;
	virtual int OnDir( const wxString & dirName )  = 0 ;
};

//#############################################################################
//
//#############################################################################

class My_DIR : public wxDir
{
  public :

    My_DIR() ;
    My_DIR( const wxString & dir ) ;

	size_t Enumerate( My_DirEnumerator & sink, 
                      const wxString & fileSpec = wxEmptyString, 
                      int flags = wxDIR_DEFAULT );
};

#endif