#include  <wx/menu.h>
#include  <wx/string.h>

//#############################################################################
//
//#############################################################################

class My_MENU : public wxMenu
{
  public :

    int  m_To_Disable ;

  public :

    My_MENU( int to_Disable = 0 )
    {
        m_To_Disable = to_Disable ;
    };

    wxMenuItem * Append_X( int id, const wxString & itemStr = wxT(""), 
                           const wxString & helpString = wxT(""), 
                           wxItemKind kind = wxITEM_NORMAL )
    {
        wxMenuItem * item ;

        item = Append( id, itemStr, helpString, kind );
        if( m_To_Disable )
            item->Enable( false ) ;

        return( item ) ;          
    };
};



