#ifndef PATH_STRING_CTL
#define PATH_STRING_CTL

#include <wx/string.h>
#include <wx/font.h>
#include <wx/window.h>
#include <wx/timer.h>
#include <wx/stattext.h>

class wxTipWindow ;

///%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//
///%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

class Path_String_CTL : public wxWindow
{
  public :

///    static const wxEventType  EVTYP_Folder_Specify ;
    static const short OPTION_RightAlign ; //0x01 = text alignment option. 
                                           //        ON -> right align 
    static  wxChar  s_TipStr_R[] ;//Text_Str_RC_Jp.cpp ɂĒ`
    static  wxChar  s_TipStr_L[] ;

  public :

    int       m_Which ;

    wxString  m_Path_String ;
    short     m_Option ;
    wxTimer   m_MM_Timer;

    int       m_Mouse_Pos ;
    
    wxString  m_TipStr_C ;

    wxStaticText * m_TipWin ;

  public :

    Path_String_CTL( wxWindow * parent, int wid,
                          int which, 
                          const wxString & str = wxT( "" ),
                          const wxString & tipSTr = wxT( "" ) ) ;
    int  Set_PathStr( const wxString & path_str );

    void OnPaint( wxPaintEvent & event );
    void OnMouseMotion( wxMouseEvent& event );
    void OnLMouseDown( wxMouseEvent& event );
    void OnMouseEnter( wxMouseEvent& event );
    void OnMouseLeave( wxMouseEvent& event );

    void OnTimerEvent( wxTimerEvent& event );
    void OnSize( wxSizeEvent& event );

    DECLARE_EVENT_TABLE()
};

#endif
