#ifndef DEF_PROC_SPACE_H
#define DEF_PROC_SPACE_H

#include  <wx/dynarray.h>
#include  "My_Dir.h"

class TopFRAME ;
class DualTreeCtl_NODE ;
typedef unsigned char BYTE ;

//#############################################################################
//
//#############################################################################

class Proc_SPACE
{
    public :

        TopFRAME * m_Frame ;
        int        m_Which ;
        short      m_GoOn_Flag  ;//<> 0 ̎̂݁As: Check_Diff, ܂ Backup  

    public :

        Proc_SPACE() ;
        Proc_SPACE( const TopFRAME * frame, int which ) ;

        void  Set( const TopFRAME * frame, int which ) ;
        int   Load_Children( DualTreeCtl_NODE * pNod_Mother );

        int   Diff_Check_Children_OnTree( DualTreeCtl_NODE * pNod_Mother );
        int   Diff_Check_Children_OnMedia( DualTreeCtl_NODE * pNod_Mother ) ;
        int   LogPut_Msg( const wxString & msg ) const ;
        int   LogPut_Format( const wxChar format[], ... )  const ;

        int   LogPut_FileCopyBegin( const wxString & src_FullPath,
                                    const wxString & dst_FullPath ) const ; 
} ;

//#############################################################################
//
//#############################################################################

class DiffChk_TRVRSR : public My_DirEnumerator
{
    public :

        Proc_SPACE    * m_pPrc_Space ;
        wxArrayString * m_FileNam_L  ;
        wxArrayString * m_FoldrNam_L ;

    public :

        DiffChk_TRVRSR( const Proc_SPACE * pPrc_Space ) ;

        void  Set( const wxArrayString * fileNam_L, 
                   const wxArrayString * foldrNam_L ) ;

        virtual int OnFile(const wxString & filename ) ;
    
        virtual int OnDir(const wxString & dirname ) ;
};

#endif  //DEF_PROC_SPACE_H
