//#include "wx/image.h"
///#include "wx/imaglist.h"
//#include "wx/treectrl.h"
//#include "wx/math.h"
//#include "wx/dirdlg.h"
//#include "wx/filedlg.h"
//#include "wx/dir.h"
//#include "wx/filename.h"
//#include "wx/txtstrm.h"
//#include "wx/wfstream.h"
//#include "wx/textfile.h"
//#include "wx/tokenzr.h"

#ifdef __WIN32__
    // this is not supported by native control
//    #define NO_VARIABLE_HEIGHT
#endif

#include "TopFRAME.h"
//#include "MyDirTraverser.h"
#include "MyThread.h"

//*****************************************************************************
//
//*****************************************************************************

void
TopFRAME::OnPaint
(
    wxPaintEvent & WXUNUSED( event ) 
)
{
//        short   flag ;
        wxRect  wr ;
        wxPen   pen ;
        wxBrush brush ;
//        wxBitmap * bmp ;

    wxPaintDC dc( this );

  //={ /100/draw vertical splitter

    wr = m_Rect_HdView_Spcer;
//    wr = wr.Inflate( -1, 0 ) ;

    dc.SetPen( * wxMEDIUM_GREY_PEN ) ;
    dc.SetBrush( * wxLIGHT_GREY_BRUSH );

    dc.DrawRectangle( wr.x, wr.y, wr.width, wr.height ) ;
  //}= /100/

  //={ /200/draw Target-On/Off indicator
#if 0   //aaaaaa
    wr = m_Rect_Root_Backup_Ind ;

    if( m_Diff_Check_Ind )
    {
    }

    pen   = * wxBLACK_PEN  ;
//    brush = wxNullBrush ;//sv-->bmp gp
    bmp   = & m_DTreeCtrl->m_Bmp_EmptySpace ;

    if( m_DTreeCtrl->m_pRoot_Node->m_Is_Valid_L[ 0 ] == 0 )
    {     //source ܂w肳ĂȂ
        pen = *wxGREY_PEN ;
        pen.SetStyle( wxDOT ) ;
    }
    else
    {
        flag = m_DTreeCtrl->m_pRoot_Node->m_Flag_Diff ;
        if( flag >= 0 )
        {
//            brush = m_DTreeCtrl->m_Brush_BkupTarget ;//sv-->bmp gp
            bmp = & m_DTreeCtrl->m_Bmp_Node_Diff_Ind[ 0 ] ;
            if( flag > 0 )
            {
                bmp = & m_DTreeCtrl->m_Bmp_Node_Diff_Ind[ 1 ] ;
            }
        }
    }

    wr = m_Rect_Root_Backup_Ind ;

    wr.Inflate( -1, -2 ) ;
 //   dc.SetClippingRegion( & wr ) ;
    dc.DrawBitmap( * bmp, wr.x, wr.y, false ) ;

    dc.SetPen( pen ) ;
    dc.SetBrush( * wxTRANSPARENT_BRUSH ) ;

    wr.Inflate( 1, 2 ) ;
    dc.DrawRectangle( wr.x, wr.y, wr.width, wr.height ) ;
#endif   //aaaaaa
}

//*****************************************************************************
//
//*****************************************************************************

void TopFRAME::OnSize(wxSizeEvent& event)
{
    if( Resize() )  return ;

    event.Skip();
}

//*****************************************************************************
//DaulTreeCtrl  post ŋN
//*****************************************************************************

void 
TopFRAME::OnShow_FileInfo( wxCommandEvent & event )
{
    Item_DrawINFO * pDrawInf ;
    DualTreeBASE_ITEM * pIBase ;
    DualTreeCtl_ITEM * pItem ;
    wxString n, s, t, str ;

    pDrawInf = (Item_DrawINFO *) event.GetClientData() ;
    pIBase   = pDrawInf->m_pItemBase ;

    for( short i = 0 ; i < 2 ; i ++ )
    {
        str = wxT("") ;

        if( pIBase  &&  pIBase->m_Is_Valid_L[ i ] )
        {
            pItem = (DualTreeCtl_ITEM *) pIBase->m_pCustomData ;
///            n = pIBase->m_Name_L[i] ;
////            s = wxT( "" );
///            s = pItem->Get_Full_Path( i ) ;
            s = pItem->Get_Relative_Path( i ) ;
            m_FileInfo_Ctl[ i ]->Set( 1, & s,
///                                      & pIBase->m_Name_L[i], 
                                      & pItem->i_Data_Size_L[i],
                                      & pItem->i_Upd_Date_L[i]  );        
        }
        else
        {
            m_FileInfo_Ctl[ i ]->Reset() ;
        }
         //::wxLogDebug( wxT("OnShow_FileInfo()  pIBase= %s"), str );

///        SetStatusText( str, i );
    }

    return ;
}

//*****************************************************************************
//
//*****************************************************************************

void
TopFRAME::OnLMouseUp
(
    wxMouseEvent & event
)
{
    if( HasCapture() )
        ReleaseMouse() ;
}

//*****************************************************************************
//
//*****************************************************************************

void
TopFRAME::OnLMouseDown
(
    wxMouseEvent & event
)
{
////090529/    int     opt, opt_1 ;
    wxPoint pos ;

            ::wxLogDebug( wxT("TopFRAME::OnLMouseDown()") );

    pos = event.GetPosition() ;

#if 0 //090529    backup check-mark
    if( m_Rect_Root_Backup_Ind.Contains( pos ) )
    {
        opt = m_DTreeCtrl->m_pRoot_Node->Backup_Option() ;

        opt_1 = (opt + 1 ) % 2 ;// 0 -> 1  or  1 -> 0

        m_DTreeCtrl->m_pRoot_Node->Set_Backup_Option( opt_1 ) ;

        Refresh() ;
                  ::wxLogDebug( wxT("OnLMouseDown(): backup_opt : opt = %d, %d"), opt, opt_1 );
        return ;
    }
#endif //090529

    if( ! m_Rect_HdView_Spcer.Contains( pos ) ) return ;

    m_X0_LMDown_Spcer = pos.x - m_Rect_HdView_Spcer.x ;

    CaptureMouse() ;
}

//*****************************************************************************
//
//*****************************************************************************

void
TopFRAME::OnLDoubleClick( wxMouseEvent & event )
{
    OnLMouseDown( event ) ;
}

//*****************************************************************************
//
//*****************************************************************************

void
TopFRAME::OnMouseMotion
(
    wxMouseEvent & event
)
{
    wxPoint pos ;
    int     w_Cli, h_Cli, offs ;

    pos = event.GetPosition() ;

    if( m_Rect_HdView_Spcer.Contains( pos ) )
    {
        SetCursor( wxCursor( wxCURSOR_SIZEWE ) );
    }
    else
    {
        SetCursor( wxNullCursor );
    }

    if( m_X0_LMDown_Spcer < 0 )
    {
            //::wxLogDebug( wxT("TopFRAME::OnMouseMotion() m_X0_LMDown_Spcer < 0" ) );
        return ;
    }

    if( ! event.m_leftDown )  goto  EXIT_Invalid ;

///    if( ! m_Rect_HdView_Spcer.Contains( pos ) )
///    {
///            //::wxLogDebug( wxT("TopFRAME::OnMouseMotion() Not Contains" ) );
///        //return ;
///    }

    GetClientSize( & w_Cli, & h_Cli ) ;
    offs = pos.x - (m_Rect_HdView_Spcer.x + m_X0_LMDown_Spcer ) ;
            //::wxLogDebug( wxT("TopFRAME::OnMouseMotion() offs=%d" ), offs );

    if( m_Rect_HdView_Spcer.GetLeft() + offs  < 100         )  return ;
    if( m_Rect_HdView_Spcer.GetRight() + offs > w_Cli - 100 )  return ;

    m_Rect_HdView_Spcer.Offset( offs, 0 ) ;

    Resize_HeadView() ;

    Refresh() ;

    return ;

  EXIT_Invalid :
            //::wxLogDebug( wxT("TopFRAME::OnMouseMotion() EXIT_Button in Up" ) );

     m_X0_LMDown_Spcer = -1 ;
}

//*****************************************************************************
//
//*****************************************************************************

void
TopFRAME::OnMouseLeave( wxMouseEvent& event )
{
    SetCursor( wxNullCursor );
}

//*****************************************************************************
//
//*****************************************************************************

void
TopFRAME::OnEvent_Thread( wxCommandEvent & event )
{
    extern wxChar   RC_Log_End_Backup[]  ;

    MyThreadEVENT * pEvt = (MyThreadEVENT *) & event ;
//    LoadTree_THREAD * pThread ;
    Proc_SPACE  prc ;
    wxString  str ;
    int id, ret ;

    id = pEvt->GetId() ;

        ::wxLogDebug( wxT("TopFRAME::OnEvent_Thread() id= %d\n"), id );

    switch( id )
    {
        case  thread_Evt_LoadTree_Finished : //090710 ݁ALoadTree() thread łȂ.-->ɂ͂Ȃ

            ret = pEvt->GetInt() ;
                    ::wxLogDebug( wxT("thread_Evt_LoadTree_Finished: ret = %d, which=%d"),
                                         ret, pEvt->m_Which );
            if( ret )
            {       //Error   //O()߂
                m_DTreeCtrl->m_pRoot_Node->m_Name_L[ pEvt->m_Which ] = pEvt->m_Path_Str_Org ;

                Check_Thread_Queue( pEvt ) ;
                goto  EXIT ;
            }

            str = m_DTreeCtrl->m_pRoot_Node->m_Name_L[ pEvt->m_Which ] ;
            m_Path_Ctl[ pEvt->m_Which ]->Set_PathStr( str ) ;

            m_DTreeCtrl->m_pRoot_Node->m_Is_Valid_L[ pEvt->m_Which ] = 1 ;

            if( pEvt->m_Which == 0 )
            {
                m_DTreeCtrl->m_pRoot_Node->Set_Backup_Option( 1 ) ;
            }

            m_DTreeCtrl->m_pRoot_Node->Sort_Children( m_DTreeCtrl->m_SortPrior_Tbl );

            Check_Thread_Queue( pEvt ) ;
            break ;

        case  thread_Evt_Backup_Finished :
        case  thread_Evt_Delete_Finished :

///            m_DTreeCtrl->m_pRoot_Node->Clear_OneSide( 1 ) ;͕KvȂ
            //destination side : Copy ŒǉꂽALoad Kv
///            pThread = new LoadTree_THREAD( this, & m_DTreeCtrl->m_Root_Node, 1 );

///            Append_Thread_Queue( pThread ) ;

            m_DTreeCtrl->m_pRoot_Node->Clear_OneSide_R( 1 ) ;//́AClear_OneSide() ͑ʖ

            prc.Set( this, 1 ) ;//1 : destination ɐݒ

            ret = prc.Load_Children( m_DTreeCtrl->m_pRoot_Node ) ;//tree Ɂ@load 

            m_DTreeCtrl->m_pRoot_Node->Sort_Children( m_DTreeCtrl->m_SortPrior_Tbl );

            if( id == thread_Evt_Backup_Finished )
            {
                LogPut_Msg( RC_Log_End_Backup ) ;
            }

            m_DTreeCtrl->m_pRoot_Node->m_DrawInf_Cursor.m_pItemBase = 0 ;

            Update() ;

            m_DTreeCtrl->m_pRoot_Node->Reset_Diff_Flag();

            KickOff_Diff_Check() ;

            Check_Thread_Queue( pEvt ) ;

            break ;

        case  thread_Evt_Chk_Diff_Finished :

            Check_Thread_Queue( pEvt ) ;

            break ;

        case  thread_Evt_Refresh_Tree :

//            m_DTreeCtrl->Refresh() ;

            break ;

        case  thread_Evt_Logging :
            m_textCtrl->AppendText( event.GetString() ) ;
            break ;

        default :
            return ;
    }

    if( m_Opt_Auto_Backup )
    {
        if( m_Idx_Thread_Work < 0 )
            Close() ;
    }

    Refresh() ;

 EXIT :

    return ;
}

//*****************************************************************************
//
//*****************************************************************************

void
TopFRAME::OnGet_RootPath( wxCommandEvent & event )
{
    int  which, ret ;
                ::wxLogDebug( wxT("OnGet_RootPath() id=%d, str=<%s>"), 
                                            event.GetId(), event.GetString() );
    which = event.GetInt() ;

    ret = Open_RootFolder_OneSide( event.GetString(), which );

    if( ret == 0 )
        KickOff_Diff_Check() ;//invoke diff_check thread  
}

//*****************************************************************************
//
//*****************************************************************************

void
TopFRAME::OnToggle_Diff_Chk( wxCommandEvent & event )
{
        int  ret ;
        bool bRet ;

    bRet = m_DiffChkBtn->GetValue() ;
                ::wxLogDebug( wxT("OnToggle_Diff_Chk() -->%d"), bRet ) ;
    if( bRet )
    {
        KickOff_Diff_Check() ;
    }
    else
    {
        Quit_Thread() ;

        m_DTreeCtrl->m_pRoot_Node->Reset_Diff_Flag() ;
        Refresh() ;
    }
}

#if 0 //090615 OnShow_About():  instead, use special dialog box
//*****************************************************************************
//
//*****************************************************************************

void
TopFRAME::OnShow_About( wxCommandEvent & event )
{
    extern  wxChar * RCL_About[] ;

    ::wxMessageBox( RCL_About[0], RCL_About[1],
                     /*wxOK | */wxICON_INFORMATION, this);
}
#endif  //090615

//*****************************************************************************
//
//*****************************************************************************

void TopFRAME::OnIdle(wxIdleEvent& event)
{
//#if wxUSE_STATUSBAR
    if ( m_DTreeCtrl )
    {
//        wxTreeItemId idRoot = m_DTreeCtrl->GetRootItem();

//        SetStatusText(wxString::Format
//                      (
//                        _T("Root/last item is %svisible/%svisible"),
//                        m_DTreeCtrl->IsVisible(idRoot) ? _T("") : _T("not "),
//                        m_DTreeCtrl->IsVisible(m_DTreeCtrl->GetLastChild(idRoot))
//                            ? _T("") : _T("not ")
//                      ), 1);
    }
//#endif // wxUSE_STATUSBAR

    event.Skip();
}

//*****************************************************************************
//
//*****************************************************************************
void
TopFRAME::OnDestroy( wxWindowDestroyEvent & event )
{
        //::wxLogDebug( wxT("TopFRAME::OnDestroy() id=%d, obj=%p"), event.GetId(), event.GetEventObject() ); 
    if( event.GetId() == ctrl_ID_About )
    {
        if( m_MenuTip_Ctl )
        {
            m_MenuTip_Ctl->Destroy() ;
        }
    }

    if( event.GetEventObject() == m_MenuTip_Ctl )
    {
        m_MenuTip_Ctl = 0 ;
    }
}
