/////////////////////////////////////////////////////////////////////////////
// Name:        MyFrame_Lib.cpp
/////////////////////////////////////////////////////////////////////////////

#define wxUSE_STREAMS 1

// For compilers that support precompilation, includes "wx/wx.h".
//#include "wx/wxprec.h"

//#ifdef __BORLANDC__
//    #pragma hdrstop
//#endif

//#ifndef WX_PRECOMP
    #include <wx/wx.h>
    #include <wx/log.h>
//#endif

///#include "wx/colordlg.h>
///#include "wx/numdlg.h>

#include  <time.h>
#include  <wx/gdicmn.h>
#include  <wx/icon.h>
#include  <wx/image.h>
///#include  <wx/imaglist.h>
//#include  <wx/treectrl.h>
#include  <wx/math.h>
#include "wx/datetime.h"
#include  <wx/dirdlg.h>
#include  <wx/filedlg.h>
#include  <wx/dir.h>
#include  <wx/filename.h>
#include  <wx/txtstrm.h>
#include  <wx/wfstream.h>
#include  <wx/textfile.h>
#include  <wx/debug.h>
#include  <wx/stattext.h>
#include  <wx/event.h>
#include  <wx/strconv.h>
//#include  <wx/tokenzr.h>

#ifdef __WIN32__
    // this is not supported by native control
    #define NO_VARIABLE_HEIGHT
#endif

#include "TopFRAME.h"
#include "MyDirTraverser.h"
#include "MyThread.h"
//#include "Backup_Diff.xpm"

#ifndef __WXMSW__
#endif

typedef  char INT_8 ;

#if 0
extern int
StrToken_Breaker
( 
    const wxString & str, 
    const wxChar     delims[], 
    int      max_Tokens,
    wxString token_L[],
    INT_8    tkTyp_L[] = 0
) ;
#endif

extern int Subtract_String
            ( 
                const wxString & text_in, 
                wxChar  subt_Symb,
                const wxString & pattern,
                int       max_tokns,
                wxString tokns_L[],         //output
                int     * cnt_Parsed        //output
            );
extern wxString Embed_Time_onCR( const wxString & msg ) ;

//extern wxChar    RC_TipStr_MenuBtn[] ;
extern wxChar    g_Recently_Used_Setting_List[] ;
//extern wxBitmap  g_Bmp_CopyDirection ;
//extern wxColour  g_Color_RootPath_BG ;

//*****************************************************************************
//
//*****************************************************************************
short 
TopFRAME::Max_Thread_Queue() const
{
    return( sizeof( m_Thread_L ) / sizeof( m_Thread_L[ 0 ] ) );
}

//*****************************************************************************
//
//*****************************************************************************
int 
TopFRAME::Append_Thread_Queue( MyThread_BASE * pThread ) 
{
        short idx ;

    idx = m_Idx_Thread_Work ;
    if( idx < 0 )  idx = 0 ;

    idx = ( idx + m_Cnt_Thread_Pend ) % Max_Thread_Queue() ;
    m_Thread_L[ idx ] = (MyThread_BASE *) pThread ;

    m_Cnt_Thread_Pend ++ ;

    if( m_Cnt_Thread_Pend == 1 )
    {
        m_Idx_Thread_Work = idx ;

        pThread = m_Thread_L[ idx ] ;

        SetCursor( * wxHOURGLASS_CURSOR );
        Enable_Operations( false ) ;

        pThread->Create() ;
        pThread->Run() ;
    }

    return( 0 ) ;
}

//*****************************************************************************
//
//*****************************************************************************
int 
TopFRAME::Check_Thread_Queue( const MyThreadEVENT * pEvt ) 
{
        MyThread_BASE * pThread ;
                ::wxLogDebug( wxT("Check_Thread_Queue(): work=%hd, Pend=%hd"), m_Idx_Thread_Work ,m_Cnt_Thread_Pend );

    m_Idx_Thread_Work = ( m_Idx_Thread_Work + 1 ) % Max_Thread_Queue() ;
    m_Cnt_Thread_Pend -- ;

    if( m_Cnt_Thread_Pend == 0 )
    {
        m_Idx_Thread_Work = -1 ;
        SetCursor( wxNullCursor ) ;
        Enable_Operations( true ) ;
    }
    else if( m_Cnt_Thread_Pend > 0 )
    {
        pThread = m_Thread_L[ m_Idx_Thread_Work ] ;
        pThread->Create() ;
        pThread->Run() ;
    }
    else
    {       //Logical Fatal Error
        int * p = 0 ;
        *p = 0 ;    //causes segmentation fault
        //::wxTrap() ;
    }

    return( 0 ) ;
}

//*****************************************************************************
//
//*****************************************************************************

int
TopFRAME::Quit_Thread( int type ) const
{
        MyThread_BASE * pThread ;

    if( m_Idx_Thread_Work < 0 )     return( 0 ) ;

    pThread = m_Thread_L[ m_Idx_Thread_Work ] ;

    if( type > 0 )
    {
        if( pThread->m_Type != type ) return( 0 ) ;
    }

    pThread->m_GoOn_Flag = 0 ;

    return( 1 );
}

//*****************************************************************************
//
//*****************************************************************************

int 
TopFRAME::Delete_Selected_Destines
( 
    int flag_Delete[]   //[0] <> 0 --> delete folder when it contains children
                        //[1] <> 0 --> delete items even if read-only
)
{
        MyThread_BASE * pThread ;

    pThread = new DelFiles_THREAD( this, m_DTreeCtrl->m_pRoot_Node, flag_Delete ) ;

    Append_Thread_Queue( pThread ) ;

    return( 0 ) ;
}

//*****************************************************************************
//
//*****************************************************************************

int
TopFRAME::Add_Recently_Used_Setting_List( wxString & setting_File )
{
    int i, cnt ;

    //={ /10/ Ô̂폜
    cnt = 0 ;

    for( i = 0 ; i < m_Cnt_Recent_Setting_Files ; i ++  )
    {
        if( m_Recent_Setting_Files_L[ i ] == setting_File )
            continue ;

        m_Recent_Setting_Files_L[ cnt ] = m_Recent_Setting_Files_L[ i ] ;
        cnt ++ ;
    }

    m_Cnt_Recent_Setting_Files = cnt + 1 ;// + 1 ́A擪ɒǉ镔܂

    //ɂ炵Đ擪ʒuɋ󂫂
    for( i = m_Cnt_Recent_Setting_Files - 1 ; i >= 0 ; i -- )
    {
        m_Recent_Setting_Files_L[ i + 1 ] = m_Recent_Setting_Files_L[ i ] ;
    }

    //擪ʒuɒǉ
    m_Recent_Setting_Files_L[ 0 ] = setting_File ;

    //}= /10/

    if( m_Cnt_Recent_Setting_Files > Max_Recent_Setting_Files() )
        m_Cnt_Recent_Setting_Files = Max_Recent_Setting_Files() ;

            ::wxLogDebug( wxT("Add_Recently_Used_Setting_List() : m_Cnt_Recent_Setting_Files =%d, <%s>, <%s>"), 
                           (int)m_Cnt_Recent_Setting_Files, (const wxChar *) m_Recent_Setting_Files_L[0], m_Recent_Setting_Files_L[1].c_str() );

    return( 0 ) ;
}

//*****************************************************************************
//
//*****************************************************************************

int  
TopFRAME::Open_RootFolder_OneSide
(
    const wxString & fullPath_Root,
    int   which    //0,1
)
{
    extern wxChar * RCL_Side_Symbol[] ;
    extern wxChar * RCL_Guide_Word_Root_Setting[];
    extern wxChar   RC_Log_Set_Root_Folder[] ;
    extern wxChar   RC_Log_Error[];
    extern wxChar   RC_Log_Ok[] ;
    extern wxChar   RC_Log_Ok[] ;

        int ret, ret1 , result;
        wxFileName  fnDirPath ;
//        MyThread_BASE * pThread ;
        wxCursor  cursor_Org ;
        wxString  old_Root ;
        Proc_SPACE  prc ;
        bool        bRet ;

    cursor_Org = GetCursor() ;
    SetCursor( * wxHOURGLASS_CURSOR );

    LogPut_Format(  RC_Log_Set_Root_Folder, 
                            RCL_Side_Symbol[ which ],
                            RCL_Guide_Word_Root_Setting[ which ],
                            fullPath_Root );

    fnDirPath.Assign( fullPath_Root + wxT('/') );

    bRet = fnDirPath.DirExists() ;
                ::wxLogDebug( wxT("Open_RootFolder_OneSide( [%s], %d ) -->%d"), fnDirPath.GetFullPath(), which, bRet );
    if( ! bRet )  goto              ERR_NoDir ;

    Quit_Thread() ;

    m_DTreeCtrl->m_pRoot_Node->m_DrawInf_Cursor.m_pItemBase = 0 ;// 

    m_DTreeCtrl->m_pRoot_Node->Clear_OneSide( which ) ;

    m_DTreeCtrl->m_pRoot_Node->m_Is_Valid_L[ which ] = 1 ;//ȂƁALoad_Children()˕t

    old_Root = m_DTreeCtrl->m_pRoot_Node->m_Name_L[ which ] ;
    m_DTreeCtrl->m_pRoot_Node->m_Name_L[ which ] = fullPath_Root ;

    prc.Set( this, which ) ;

    ret = prc.Load_Children( m_DTreeCtrl->m_pRoot_Node ) ;

    if( ret )
    {         //Error B Root ɖ߂
        m_DTreeCtrl->m_pRoot_Node->Clear_OneSide( which ) ;
        m_DTreeCtrl->m_pRoot_Node->m_Name_L[ which ] = old_Root ;

        ret1 = prc.Load_Children( m_DTreeCtrl->m_pRoot_Node ) ;

        if( ret1 )  goto  ERR_NoDir ;
    }

    m_DTreeCtrl->m_pRoot_Node->Sort_Children( m_DTreeCtrl->m_SortPrior_Tbl );

    m_Path_Ctl[ which ]->Set_PathStr( fullPath_Root ) ;


    result = 0 ;

    m_textCtrl->AppendText( RC_Log_Ok ) ;

 EXIT :

    m_DTreeCtrl->Refresh() ;

    SetCursor( cursor_Org );

    return( result ) ;

 ERR_NoDir :

    m_textCtrl->AppendText( RC_Log_Error ) ;

    result = 1 ;
    goto  EXIT ;
}

//*****************************************************************************
//  Load_Children()  thread version  (090720)gp
//*****************************************************************************

int  
TopFRAME::Open_RootFolder_OneSide_Th
(
    const wxString & fullPath_Root,
    int   which
)
{
//        int ret ;
        wxFileName  fnDirPath( fullPath_Root ) ;
        MyThread_BASE * pThread ;

    if( ! fnDirPath.DirExists() )  goto  ERR_NoDir ;

    Quit_Thread() ;

    m_DTreeCtrl->m_pRoot_Node->Clear_OneSide( which ) ;

    m_DTreeCtrl->m_pRoot_Node->m_Is_Valid_L[ which ] = 1 ;//ȂƁALoad_Children()˕t

    pThread = new LoadTree_THREAD( this, m_DTreeCtrl->m_pRoot_Node, 
                                                              which ) ;
    m_DTreeCtrl->m_pRoot_Node->m_Name_L[ which ] = fullPath_Root ;

    Append_Thread_Queue( pThread ) ;

    KickOff_Diff_Check() ;

 //EXIT :

    return( 0 ) ;

 ERR_NoDir :

    return( 1 ) ;

///    MyDirTraverser traverser( which, tree_Body ) ;
                             
///    dir.Traverse( traverser, wxEmptyString, 
///                       wxDIR_FILES | wxDIR_DIRS | wxDIR_HIDDEN );

///    return( 0 ) ;
}

//*****************************************************************************
//message  textctrl(m_textCtrl) ɕ\B
//*****************************************************************************

void
TopFRAME::LogPut_Msg( const wxString & msg ) const
{
    m_textCtrl->AppendText( Embed_Time_onCR( msg ) ) ;
}

//*****************************************************************************
//message format  textctrl(m_textCtrl) ɕ\B
//*****************************************************************************

void
TopFRAME::LogPut_Format
( 
    const wxChar  format[],
    ...
)  const
{
        wxString  msg ;
        va_list   argPtr ;

    va_start( argPtr, format ) ;

    msg.PrintfV( format, argPtr ) ;

    LogPut_Msg( msg ) ;

    return ;
}
